*         SPHINX--SINIT.S

*         CONSOLIDATE NUMBER INITIALIZATIONS

          ZERODEF

          RSEG    CODE9


**********PREINIT***************************************************************
PREINIT                                  ;SET UP POWER UP DEFAULTS

          LDX     #1                     ;SETS DEFAULT MODES FOR STARTUP
          STX     NUMPLYRS
          STX     DIFCULTY               ;STANDARD DIFFICULTY LEVEL
          DEX                            ;PLAYER ONE ONLY
          STX     PLAYER
          LDX     #5                     ;FIVE LIVES ONLY
          STX     PL1LIVES
          STX     PL2LIVES

          JSR     INITGAME
          JSR     MCPINIT
          RTS


**********INITIT****************************************************************

INITIT                                   ;INITIALIZE STATE TO TITLE PAGE + MENU

          JSR     ABSZERO                ;ZERO OUT ABSOLUTE MEMORY
          JSR     BLANKMAP               ;BLANK OUT CHARACTER MAP
          JSR     SCRAPALL               ;KILL ALL TUNES
          JSR     IOINIT                 ;SET UP SOFTWARE IO REGISTERS
          JSR     DLYZFILL               ;FILL UP DLY AND DLZ

          LDA     #$80                   ;RESET EAST AND WEST JOYSTICK TIMERS
          STA     ETIMER
          STA     WTIMER
          STA     STIMER                 ;SELECT TIMER

          LDA     #35                    ;DISABLE SELECTION FOR FIRST 35 FRAMES
          STA     OTIMER                 ;OF SELECT MODE

NODELAY
          LDX     #74                    ;COPY TITLE PAGE DISPLAY LIST LIST
DTITLOOP  LDA     TITBL,X
          STA     DLLIST,X
          DEX
          BPL     DTITLOOP

          LDA     #L(TITSTATE)           ;SET UP STATE POINTER FOR INDIRECT JMP
          STA     STATEPTR               ;TO TITSTATE
          LDA     #H(TITSTATE)
          STA     STATEPTR+1

          LDA     #$4C
          STA     HANDLER
          LDA     #L(DLITIT)             ;SET UP DLI POINTER FOR THE DLI
          STA     DLIPTR                 ;OF TITLEPAGE
          LDA     #H(DLITIT)
          STA     DLIPTR+1

TITLOGO
          LDA     #H(TITCHR1)            ;LOAD HIGH BYTE OF TITLE PAGE CHARS
          STA     CHARBASE               ;INTO CHARBASE

          LDA     #L(DLLIST)             ;SET UP DPPL AND DPPH FOR TITLE PAGE
          STA     DPPL
          LDA     #H(DLLIST)
          STA     DPPH

          LDX     #79
          LDA     #0
ZERODL    STA     DL0,X
          STA     DL1,X
          STA     DL2,X
          STA     DL3,X
          STA     DL4,X
          STA     DL5,X
          DEX
          BPL     ZERODL


          LDX     #4                     ;FILL DLISTS
TITZNLP   LDA     TITZN0TB,X             ;WING HEADER FOR DL0
          STA     DL0,X
          LDA     TITZN1TB,X
          STA     DL1,X
          LDA     TITZN2TB,X             ;WING HEADER FOR LEFT SIDE OF DL2
          STA     DL2,X
          LDA     TTZN2TB2,X             ;WING HEADER FOR RIGHT SIDE OF DL2
          STA     DL2+5,X
          LDA     TITZN3TB,X
          STA     DL3,X
          LDA     TITZN4TB,X
          STA     DL4,X
          LDA     TITZN5TB,X
          STA     DL5,X

          LDA     CRTB1,X                ;CREST HEADERS
          STA     DL1+5,X
          LDA     CRTB2,X
          STA     DL2+10,X
          LDA     CRTB3,X
          STA     DL3+5,X
          LDA     CRTB4,X
          STA     DL4+5,X
          LDA     CRTB5,X
          STA     DL5+5,X

          LDA     NOVHDTBL,X             ;NOVICE HEADER MAP
          STA     DL6,X
          LDA     STDHDTBL,X             ;STANDARD HEADER MAP
          STA     DL6+5,X
          LDA     ADVHDTBL,X             ;ADVANCED HEADER MAP
          STA     DL6+10,X
          LDA     EXPHDTBL,X             ;EXPERT HEADER MAP
          STA     DL6+15,X
          LDA     CRHDTBL,X              ;CRIGHT MESSAGE MAP HEADER
          STA     DL7,X

          DEX
          BPL     TITZNLP

          LDX     #3
PAULOOP   LDA     DSTOPSTP,X             ;'DESERT FALCON' TEXT IS DONE IN DIRECT
          STA     DL1+10,X               ;MODE
          LDA     FCTOPSTP,X
          STA     DL1+14,X
          LDA     DSSTPSTP,X
          STA     DL2+15,X
          LDA     FCSTPSTP,X
          STA     DL2+19,X
          LDA     DSBOTSTP,X
          STA     DL2+23,X
          LDA     FCBOTSTP,X
          STA     DL2+27,X
          LDA     DSSBTSTP,X
          STA     DL3+10,X
          LDA     FCSBTSTP,X
          STA     DL3+14,X

          DEX
          BPL     PAULOOP

          JSR     PLAYTWID               ;TURN ON CORRECT PLAYER
          JSR     DIFFTWID               ;TURN ON CORRECT DIFFICULTY

          LDX     #10                    ;FILLS TOPMSMAP WITH 'PLAYER TEXT'
MOON      LDA     PLUTOTBL,X             ;TWO PLAYER ON TOP
          STA     TOPMSMAP+2,X
          LDA     MOONTBL,X              ;ONE PLAYER ON BOTTOM
          STA     BOTMSMAP+2,X
          DEX
          BPL     MOON
          LDA     #50                    ;TWO PLAYER ON TOP
          STA     DLY+9
          LDA     #48                    ;ONE PLAYER ON BOTTOM
          STA     DLZ+9

          LDX     #19                    ;FILL CHAR MAPS WITH CHARS FOR WINGS
WINGSLP   LDA     WNGMPTB0,X             ;FOR WING MAPS 0 THRU 2
          STA     WINGMAP0,X
          LDA     #L(WINGS1)
          STA     WINGMAP1,X
          STA     WINGMAP2,X
          DEX
          BPL     WINGSLP
          LDA     #L(WINGS0)             ;HACK FIRST AND LAST CHAR OF WINGMAP2
          STA     WINGMAP2               ;THIS IS TO SAVE BYTES YOU REALIZE
          LDA     #L(WINGS2)
          STA     WINGMAP2+19

          LDX     #17                    ;FILL CHAR MAPS 3 AND 4
          LDA     #L(WINGS1)
WNGSLP34  STA     WINGMAP3,X
          STA     WINGMAP4,X
          DEX
          BPL     WNGSLP34
          LDA     #L(WINGS6)             ;HACK IN END CHARACTERS AS USUAL
          STA     WINGMAP3
          LDA     #L(WINGS0)
          STA     WINGMAP4
          LDA     #L(WINGS9)
          STA     WINGMAP3+17
          LDA     #L(WINGS2)
          STA     WINGMAP4+17

          LDX     #9                     ;FILL WINGMAP5
          LDA     #L(WINGS1)
WNGSLP5   STA     WINGMAP5,X
          DEX
          BPL     WNGSLP5
          LDA     #L(WINGS7)             ;HACK ENDS OF CHARACTER MAP
          STA     WINGMAP5
          LDA     #L(WINGS8)
          STA     WINGMAP5+9

          LDX     #29                    ;FILL CREST MAP
          LDA     #L(WINGS1)
CRSTLP    STA     CRSTMAP1,X
          DEX
          BPL     CRSTLP
          LDA     #L(WINGS0)
          STA     CRSTMAP1
          STA     CRSTMAP1+12
          STA     CRSTMAP1+22
          STA     CRSTMAP1+28
          LDA     #L(WINGS2)
          STA     CRSTMAP1+11
          STA     CRSTMAP1+21
          STA     CRSTMAP1+25
          STA     CRSTMAP1+29

          LDX     #11                    ;STUFF MESSAGE MAP WITH COPYRIGHT MSG
SLEEP     LDA     CRIGHTBL,X
          STA     CRMAP,X
          DEX
          BPL     SLEEP

          LDX     #27                    ;STUFF DIFFICULTY MAPS
DIFMAPLP  LDA     DIFTBL,X               ;ALL DIFF MAPS ARE CONTIGUOUS IN MEM.
          STA     NOVMAP,X
          DEX
          BPL     DIFMAPLP

          LDX     #2                     ;STUFF PALETTES FOR TITLE PAGE
PALSTFLP  LDA     #$0F                   ;CONSTANT
          STA     P0C1,X
          LDA     PALWD1,X
          STA     P1C1,X
          LDA     PALWD2,X
          STA     P2C1,X
          LDA     PALWD3,X
          STA     P3C1,X
          LDA     PALWD4,X
          STA     P4C1,X
          LDA     #$04                   ;CONSTANT
          STA     P5C1,X
          DEX
          BPL     PALSTFLP
          LDA     #$00                   ;LAST BUT NOT LEAST: BACKGRND
          STA     BACKGRND

          RTS

INITLOGO
          LDX     #23
FILLLOGO  LDA     LOGOTBL,X
          STA     DLLIST,X
          DEX
          BPL     FILLLOGO


          LDA     #$4C
          STA     HANDLER
          LDA     #L(DLIHSC0)            ;SET UP DLI POINTER FOR THE DLI
          STA     DLIPTR                 ;OF TITLEPAGE
          LDA     #H(DLIHSC0)
          STA     DLIPTR+1

          JMP     TITLOGO                ;COMMON TITLE PAGE AND LOGO INITS.

TITBL                                    ;22 HEADERS = 66 BYTES LONG
          ; FIRST THE 25 BLANK LINES
          DB      $4F,H(NULHDR),L(NULHDR)
          DB      $48,H(NULHDR),L(NULHDR)

          ; VISIBLE SCREEN HAS 192 LINES
          ;       FIRST WE HAVE 24 BLANK LINES
          DB      $47,H(NULHDR),L(NULHDR)
          DB      $4F,H(NULHDR),L(NULHDR)

          ;       THEN WE HAVE 6 ZONES OF EIGHT HIGH FOR TITLE AND LOGO
          DB      $C7,H(DL0),L(DL0)              ;1ST ZONE TIT PG. WITH INTER.
          DB      $47,H(DL1),L(DL1)              ;2ND ZONE OF TIT PG
          DB      $47,H(DL2),L(DL2)              ;3RD ZONE OF TIT PG
          DB      $47,H(DL3),L(DL3)              ;4TH ZONE OF TIT PG
          DB      $47,H(DL4),L(DL4)              ;5TH ZONE OF TIT PG
          DB      $47,H(DL5),L(DL5)              ;6TH ZONE OF TIT PG

          ;       THEN THERE ARE 64 MORE BLANK LINES
          DB      $4F,H(NULHDR),L(NULHDR)
          DB      $4F,H(NULHDR),L(NULHDR)
          DB      $4F,H(NULHDR),L(NULHDR)
          DB      $4F,H(NULHDR),L(NULHDR)

          ;       NOW WE HAVE ONE PLAYER MAP:  8 LINES
          DB      $C7,H(DLY),L(DLY)

          ;       THEN TWO BLANK LINES
          DB      $41,H(NULHDR),L(NULHDR)

          ;       DIFFICULTY LEVEL:  8 LINES
          DB      $47,H(DL6),L(DL6)

          ;       TWO BLANK LINES
          DB      $41,H(NULHDR),L(NULHDR)

          ;       TWO PLAYER MAP:  8 LINES
          DB      $47,H(DLZ),L(DLZ)

          ;       8 BLANK LINES
          DB      $47,H(NULHDR),L(NULHDR)
          ;       COPYRIGHT MESSAGE:  8 LINES
          DB      $47,H(DL7),L(DL7)
          ;       16 BLANK LINES
          DB      $43,H(NULHDR),L(NULHDR)
          ;       16 MORE: 8 OF WHICH ARE ON THE SCREEN AND 8 WHICH ARE NOT
          DB      $4F,H(NULHDR),L(NULHDR)
          ;       THE REMAING 32 ARE OFF THE SCREEN
          DB      $4F,H(NULHDR),L(NULHDR)
          DB      $CF,H(NULHDR),L(NULHDR)        ;25 NEEDED, EXTRA FOR SAFETY

CRIGHTBL  DB      L(CRIGHT),L(BLANKCHR),L(A),L(T),L(A),L(R),L(I),L(BLANKCHR)
          DB      1,9,8,4                ;12 LONG EGGHEAD

LOGOTBL                                  ;DLL FOR LOGO ON HSC
                                         ;8 HEADERS 24 BYTES LONG
          ; FIRST THE 24 BLANK LINES    ---TRUST ME, MGF
          DB      $CF,H(NULHDR),L(NULHDR)  ;DLI HERE TO SET COLORS AND STUFF
          DB      $47,H(NULHDR),L(NULHDR)

          ;       THEN WE HAVE 6 ZONES OF EIGHT HIGH FOR TITLE AND LOGO
          DB      $47,H(DL0),L(DL0)              ;1ST ZONE TIT PG.
          DB      $47,H(DL1),L(DL1)              ;2ND ZONE OF TIT PG
          DB      $47,H(DL2),L(DL2)              ;3RD ZONE OF TIT PG
          DB      $47,H(DL3),L(DL3)              ;4TH ZONE OF TIT PG
          DB      $47,H(DL4),L(DL4)              ;5TH ZONE OF TIT PG
          DB      $47,H(DL5),L(DL5)              ;6TH ZONE OF TIT PG  WITH INTER

*         HEADERS FOR WINGS
TITZN0TB  DB      L(WINGMAP0),$60,H(WINGMAP0),$2C,0
TITZN1TB  DB      L(WINGMAP1),$60,H(WINGMAP1),$2C,0

TITZN2TB  DB      L(WINGMAP2),$60,H(WINGMAP2),$3A,0
TTZN2TB2  DB      L(WINGMAP2+14),$60,H(WINGMAP2+14),$3A,112

TITZN3TB  DB      L(WINGMAP3),$60,H(WINGMAP3),$2E,8
TITZN4TB  DB      L(WINGMAP4),$60,H(WINGMAP4),$2E,8
TITZN5TB  DB      L(WINGMAP5),$60,H(WINGMAP5),$36,40

*         HEADERS FOR CREST
CRTB1    DB      L(CRSTMAP1),$60,H(CRSTMAP1),$54,32
CRTB2    DB      L(CRSTMAP2),$60,H(CRSTMAP2),$56,40
CRTB3    DB      L(CRSTMAP3),$60,H(CRSTMAP3),$5C,64
CRTB4    DB      L(CRSTMAP4),$60,H(CRSTMAP4),$5E,72
CRTB5    DB      L(CRSTMAP5),$60,H(CRSTMAP5),$5E,72

*         HEADERS FOR ALL PARTS OF 'DESERT FALCON' TEXT
DSTOPSTP  DB      L(TITCHR1),$94,H(TITCHR1),28
FCTOPSTP  DB      L(TITCHR13),$94,H(TITCHR13),84
DSBOTSTP  DB      L(TITCHR7),$94,H(TITCHR7),28
FCBOTSTP  DB      L(TITCHR19),$94,H(TITCHR19),84
DSSTPSTP  DB      L(TITCHR1),$74,H(TITCHR1),32
FCSTPSTP  DB      L(TITCHR13),$74,H(TITCHR13),88
DSSBTSTP  DB      L(TITCHR7),$74,H(TITCHR7),32
FCSBTSTP  DB      L(TITCHR19),$74,H(TITCHR19),88

*         HEADERS FOR DIFFICULTY MAPS
NOVHDTBL  DB      L(NOVMAP),$60,H(NOVMAP),$BA,12
STDHDTBL  DB      L(STDMAP),$60,H(STDMAP),$B8,44
ADVHDTBL  DB      L(ADVMAP),$60,H(ADVMAP),$B8,84
EXPHDTBL  DB      L(EXPMAP),$60,H(EXPMAP),$BA,124

*         HEADER FOR CRIGHT MESSAGE
CRHDTBL   DB      L(CRMAP),$60,H(CRMAP),$14,56

*         CHAR MAP TABLE FOR WINGS
WNGMPTB0  DB      L(WINGS3),L(WINGS4),L(WINGS4),L(WINGS4),L(WINGS4),L(WINGS4)
          DB      L(WINGS4),L(WINGS4),L(WINGS4),L(WINGS5),L(WINGS3),L(WINGS4)
          DB      L(WINGS4),L(WINGS4),L(WINGS4),L(WINGS4),L(WINGS4),L(WINGS4)
          DB      L(WINGS4),L(WINGS5),L(WINGS3)

*         CHAR MAP TABLE FOR DIFFICULTY MAP
DIFTBL    DB      L(N),L(O),L(V),L(I),L(C),L(E),L(S),L(T),L(A),L(N),L(D),L(A)
          DB      L(R),L(D),L(A),L(D),L(V),L(A),L(N),L(C),L(E),L(D)
          DB      L(E),L(X),L(P),L(E),L(R),L(T)

*         PALETTES FOR TITLE PAGE
PALWD1    DB      $31,$3A,$16            ;PALETTE 1 USED FOR WINGS
PALWD2    DB      $00,$00,$31            ;CREST (NOT THE TOOTHPASTE!)
PALWD3    DB      $11,$10,$10            ;SHADOWS
PALWD4    DB      $1B,$37,$44            ;TITLE

*         CHAR MAPS FOR ONE AND TWO PLAYER SHIT
MOONTBL   DB      L(BLANKCHR),L(O),L(N),L(E),L(BLANKCHR),L(P),L(L),L(A),L(Y)
          DB      L(E),L(R)
PLUTOTBL  DB      L(T),L(W),L(O),L(BLANKCHR),L(P),L(L),L(A),L(Y),L(E),L(R),L(S)

*         THIS TURNS ON THE BRIGHTNESS OF THE CURRENT DIFFICULTY LEVEL
DIFFTWID
          LDX     #3
DULLOUT   LDY     DLDEXTBL,X             ;FIRST DULL THEM ALL OUT
          LDA     DFPWDLL,X
          STA     DL6,Y
          DEX
          BPL     DULLOUT

          LDX     DIFCULTY               ;THEN BRIGHTEN THE CORRECT ONE
          LDY     DLDEXTBL,X
          LDA     DFPWBRT,X
          STA     DL6,Y
          RTS

*         WRITES DIFF LEVEL AND NUM. PLAYERS INTO TIT PAGE DISPLAY
DLDEXTBL  DB      3,8,13,18
DFPWBRT   DB      $1A,$18,$18,$1A        ;BRIGHT
DFPWDLL   DB      $BA,$B8,$B8,$BA        ;DULL

PLAYTWID  ;TURN ON CORRECT PLAYER
          LDA     #$10                   ;TURN ON: PALETTE 0, WIDTH 12
          LDY     #$B0                   ;TURN OFF: PALETTE 3, WIDTH 12

          LDX     NUMPLYRS
          DEX
          BNE     TWOTWO

          STY     DLY+8                  ;TURN OFF TWO PLAYERS
          STA     DLZ+8                  ;TURN ON ONE PLAYER
          RTS

TWOTWO    STA     DLY+8                  ;TURN ON TWO PLAYERS
          STY     DLZ+8                  ;TURN OFF ONE PLAYER
          RTS

**********RANDOM INITS**********************************************************
*         ABSZERO:  ZEROES OUT 7800 RAM
ABSZERO
          LDA     #$18                   ;zero out absolute memory
          STA     PTR0+1                 ;this does pages 18 - 20
          LDA     #0
          STA     NULHDR
          STA     NULHDR+1
          STA     PTR0
          TAY
ABSZERLP  STA     (PTR0),Y
          DEY
          BNE     ABSZERLP
          INC     PTR0+1
          LDX     PTR0+1
          CPX     #$20
          BNE     ABSZERLP

          LDX     #$22                   ;THIS DOES PAGES 22 THRU 27
          STX     PTR0+1                 ;A BETTER BE ZERO HERE OR ELSE
REST0LP   STA     (PTR0),Y
          DEY
          BNE     REST0LP
          INC     PTR0+1
          LDX     PTR0+1
          CPX     #$28
          BNE     REST0LP

          RTS

*         DLYZFILL:  FILLS CHAR MAP AT BOTTOM OF SCREEN
DLYZFILL
          LDX     #$E
YZFILL    LDA     YFILL,X
          STA     DLY,X
          LDA     ZFILL,X
          STA     DLZ,X
          DEX
          BPL     YZFILL
          RTS


*         BLANKMAP: BLANKS OUT CHARACTER MAP ON BOTTOM OF SCREEN
BLANKMAP
          LDX     #39                    ;BLANK OUT CHARACTER MAP ON BOTTOM
          LDA     #L(BLANKCHR)
LULUPE    STA     PL1MAP,X
          STA     PL1LVMAP,X
          DEX
          BPL     LULUPE
          RTS

*         IOINIT:  INITIALIZE SOFTWARE IO REGISTERS
IOINIT
          LDA     #$0B
          STA     SWCHBIO
          STA     OLDSWCHB
          LDA     #$FF
          STA     LEFTBUT+1
          STA     LEFTBUT
          STA     RIGHTBUT
          STA     RIGHTBUT+1
          RTS

**********TOTINIT***************************************************************
TOTINIT
          JSR     ABSZERO                ;ZERO OUT ABSOLUTE MEMORY
          JSR     BLANKMAP               ;BLANK OUT CHARACTER MAP
          JSR     DLYZFILL               ;FILL DLISTS FOR BOT OF SCREEN DISPLAY
          JSR     IOINIT                 ;INITIALIZE SOFTWARE IO REGISTERS
          JSR     SCRAPALL               ;KILLS ALL TUNES
          JSR     COLINIT                ;INITIALIZE PALETTES

          LDX     #59                    ;COPY DISPLAY LIST LIST
DLLLOOP   LDA     DLTBL,X
          STA     DLLIST,X
          DEX
          BPL     DLLLOOP

          LDX     #3
STFLIST
          LDY     ZREFTBL,X              ;INIT LIST REF PNTS
          LDA     IDXTBL,X
          STA     DXTBL,Y
          STA     DFTBL,Y
          LDA     IRLTBL,X
          STA     RLTBL,Y
          LDA     ILLTBL,X
          STA     LLTBL,Y
          DEX
          BPL     STFLIST

          ;THIS LOOP SETS UP SCROLLING OBJECT AREA TO BE EMPTY

          LDA     #SCRENBOT+1
          LDX     #79                    ;FILL VPTBL WITH SCRENBOT+1'S

FILLVPLP  STA     VPTBL,X
          DEX
          BPL     FILLVPLP

          ; THIS LOOP INITIALIZES THE SCROLLING OBJECT QUEUE
          LDX     #PYRSTOP-PYRSTART
          LDY     #PYRSTART
KILLJACK  TYA
          STA     SLOTQ,X
          INY
          DEX
          BPL     KILLJACK

          LDA     #0
          STA     SLOTGPTR
          STA     SLOTRPTR

          ; THIS LOOP INITIALIZES THE SCROLLING OBJECT BUFFER
          LDX     #9
          STX     FRBUFPTR               ;INIT STACK POINTER
ISOBLOOP  LDA     #-1
          STA     STAMPID,X
          TXA
          STA     FRBUFSTK,X             ;PUT ALL BUFFER LOCATIONS IN FREE STACK
          DEX
          BPL     ISOBLOOP

          ; THIS LOOP INITIALIZES THE MINI SPHINX TABLE
          LDX     #MININUMB-1
          LDA     #$FF
MINITLP   STA     MINITBL,X
          DEX
          BPL     MINITLP

          ; THIS LOOP INITIALIZES THE FIRE POT TABLE
          LDX     #FIRENUMB-1
          LDA     #$FF
FIRETLP   STA     FIRETIP,X
          DEX
          BPL     FIRETLP

;         OF COURSE, X IS NOW FF
          STX     HIEROSLT               ;SLOT NUMBER FOR HIERO ANIMATION
          STX     IOSIM                  ;SIMULATED JOYSTICK INPUT OF FF
          STX     ZONEOFF
          STX     UWEOK                  ;OK TO START UWE
          STX     WAITCNT                ;REST WAIT COUNTER
          STX     OSCRLCNT
          DEX                            ;AND AN FE
          STX     JERKOFF

          LDA     #80                    ;THIS IS DEFINED IN GAME AS ZBIRDZ
          STA     ZTBL+ZBIRD

          LDA     #H(CHARS)              ;CHARBASES
          STA     CHARBASE
          STA     D11CBASE

;
;  INITIALIZE DISPLAY LISTS
;
          LDX     #11
          LDA     #L(DL11)
          STA     PTR0
UPTOP     LDA     HIBYE,X
          STA     PTR0+1
          LDY     #6                     ;Y=6
          LDA     #00
          STA     (PTR0),Y               ;TO END DMA
          DEY                            ;Y=5
          STA     (PTR0),Y               ;TO END DMA
          DEY                            ;Y=4
          STA     (PTR0),Y               ;HPOS
          DEY                            ;Y=3
          LDA     #ZPALWID
          STA     (PTR0),Y
          DEY                            ;Y=2
          LDA     #H(ZBUFFB)
          STA     (PTR0),Y
          DEY                            ;Y=1
          LDA     #$60                   ;160X2 INDIRECT MODE
          STA     (PTR0),Y
          DEY                            ;Y=0
          LDA     #L(ZBUFFB)
          STA     (PTR0),Y
          DEX
          BPL     UPTOP

          ;MORE RANDOM INITIALIZATIONS
          LDA     #1                     ;1
          STA     NEXFRAME
          LDA     #8                     ;NUMBER OF FLEAS AVAILABLE
          STA     NUMFLEAS               ;THE SCREEN
          LDA     #11
          STA     BUFDEX

          LDA     #2                     ;2
          STA     FIRECNT

;
; CODE TO SET UP FOR LOADER
;
          LDX     #23
          LDY     #H(DL11)
INITLP9   STY     ZNDLPOS,X
          DEY
          DEX
          DEX
          BPL     INITLP9

          LDA     #H(DL8)                ;MULTIMEGAHACK
          STA     ZNDLPOS+17
          LDA     #H(DL9)
          STA     ZNDLPOS+19
                                         ;INITIALIZE LISTS WITH REFERENCE
          LDA     #ZREF0                 ;POINTS
          STA     LOWEST
          LDA     #ZREF3
          STA     HIGHEST

          LDX     #ZSHAD                 ;INSERT SHADOW AND BIRD INTO LIST
          LDA     #$FE
          STA     TEMP6
          STA     TEMP10
          JSR     OBJINS
          LDX     #ZBIRD
          LDA     #50
          STA     TEMP6
          LDA     #60
          STA     TEMP10
          JSR     OBJINS

          ;SET UP PW'S FOR THINGS THAT ARE CONSTANT
          ;PUT SHTBL IN ROM
TESTHERE  LDA     #$1C
          STA     PWTBL+ZBIRD
          LDA     #$3C
          STA     PWTBL+ZSHAD

          ;AND SOME HIGH BYTES

          LDA     #H(BIRDFMS)            ;STORE SH'S AND SM'S
          STA     SHTBL+ZBIRD
          STA     SHTBL+ZSHAD
          CLC
          ADC     #1
          STA     SMTBL+ZBIRD
          STA     SMTBL+ZSHAD

          LDX     #3
STFLP
          LDA     #$3E
          STA     PWTBL+SHOTSHAD,X
          STA     PWTBL+SPXSHTSH,X

          LDA     #$1E                   ; PALETTE 0, 8 WIDE
          STA     PWTBL+ZSHOT1,X
          LDA     #$9E
          STA     PWTBL+SPHXSHOT,X

          LDA     #H(SHOTAN0)
          STA     SHTBL+ZSHOT1,X
          STA     SHTBL+SHOTSHAD,X
          CLC
          ADC     #1
          STA     SMTBL+ZSHOT1,X
          STA     SMTBL+SHOTSHAD,X

          LDA     #H(SPSHOTST)           ;SPHINX SHOT
          STA     SHTBL+SPHXSHOT,X
          STA     SHTBL+SPXSHTSH,X
          CLC
          ADC     #17-5
          STA     SMTBL+SPHXSHOT,X
          STA     SMTBL+SPXSHTSH,X

          LDA     #L(SPSHOTST)           ;SPHINX SHOT
          STA     SLTBL+SPHXSHOT,X
          STA     SLTBL+SPXSHTSH,X

          LDA     IPTBLLO,X              ;INIT CIRCULAR BUFFER FOR LOOKAHEAD
          STA     PTRTBLLO,X             ;CHAR MAP POINTER TABLE TO DIRT ONLY

          LDA     IPTBLHI,X
          STA     PTRTBLHI,X

          DEX
          BPL     STFLP

          ;THOSE TRICKY SM'S

          LDA     #2
          STA     SCRATE

          LDA     MASK9L+2               ;STUFF MASKS AS WELL
          STA     LEFTMASK
          LDA     MASK9L+1
          STA     LEFTMASK+1
          LDA     MASK9L
          STA     LEFTMASK+2
          LDA     MASK9L+3
          STA     LEFTMASK+3

          LDA     MASK9R+2               ;STUFF MASKS AS WELL
          STA     RIGTMASK
          LDA     MASK9R+1
          STA     RIGTMASK+1
          LDA     MASK9R
          STA     RIGTMASK+2
          LDA     MASK9R+3
          STA     RIGTMASK+3

          LDX     #2
          STX     STUFFDEX
          INX
          STX     LOADFDEX
          RTS

IDXTBL    DB      2*NUMBER,200,140,80
ILLTBL    DB      $FF
ZREFTBL   DB      ZREF0
IRLTBL    DB      ZREF1,ZREF2,ZREF3,$FF

IPTBLLO   DB      L(BLOCK9+66),L(BLOCK9+33),L(BLOCK9),L(BLOCK9+99)
IPTBLHI   DB      H(BLOCK9+66),H(BLOCK9+33),H(BLOCK9),H(BLOCK9+99)

TOTINIT2
          JSR     MCPINIT2

          LDA     #$F1                   ;DO SCROLLS TO FILL SCREEN
JSRAGAIN
          PHA
          JSR     VSCRP
          JSR     RANDOM
          JSR     GRNDMCP
          JSR     SCRLOAD
          JSR     NEWBLOCK
          LDA     #0
          STA     GSCRFLAG
          STA     GCOARSE
          JSR     SCROLL
          PLA
          TAY
          DEY
          TYA
          BNE     JSRAGAIN

          LDA     #0
          STA     SCRATE                 ;TO STOP SCROLLING
          STA     SCROLLS                ;TO KEEP FROM SCROLLING AGAIN

          JSR     CLRPFLGS
          JSR     PLACEMNT               ;PUT THAT BIRD DOWN
                                         ; THIS DOES PROJECTION
          LDA     SHADANAD,Y
          STA     SLTBL+ZSHAD

          LDA     #L(DLLIST)             ;SET UP DLIST LIST POINTER
          STA     DPPL
          LDA     #H(DLLIST)
          STA     DPPH

          LDA     #L(DLITOP)             ;INTERRUPT SHIT
          STA     DLIPTR
          LDA     #H(DLITOP)             ;ONLY TIME DLIPTR+1 IS STORED!!!!
          STA     DLIPTR+1

          LDA     #$80
          STA     RUNLOAD                ;FLAG TO ENABLE LOADER
          JSR     LOADER                 ;once for good luck

          RTS

INITGAME  LDA     #L(GAMSTATE)
          STA     STATEPTR
          LDA     #H(GAMSTATE)
          STA     STATEPTR+1

          JSR     INITNPLR

          LDA     #5
          STA     PL1LIVES
          STA     PL2LIVES

          LDA     #40                    ;UNDO AUTO PLAY HACK
          STA     DLZ+9

          LDA     #$50                   ;SET UP TREASURE BASE VALUE
          STA     TRVAL1+1
          STA     TRVAL2+1

          LDA     #1                     ;INITIALIZE TREASURE MULTIPLIERS
          STA     JEWCNT
          STA     JEWCNT+1
          STA     BARCNT
          STA     BARCNT+1
          STA     EGGCNT
          STA     EGGCNT+1

BCKSTART                                 ;STARTUP BACKGROUND TUNE
          LDX     #1
BCKINTLP  LDA     #$0
          STA     VBRUN,X
          LDA     #$1
          STA     DBK0,X
          LDA     #$FF
          STA     TBINDX0,X
          STA     CBINDX0,X
          STA     VBINDX0,X
          DEX
          BPL     BCKINTLP

          RTS

PLYONTBL  DB      L(BLANKCHR),L(BLANKCHR)
          DB      L(P),L(L),L(A),L(Y),L(E),L(R),L(BLANKCHR),L(O),L(N),L(E)
          DB      L(BLANKCHR),L(BLANKCHR)
PLYTWTBL  DB      L(BLANKCHR),L(BLANKCHR)
          DB      L(P),L(L),L(A),L(Y),L(E),L(R),L(BLANKCHR),L(T),L(W),L(O)
          DB      L(BLANKCHR),L(BLANKCHR)

INITNPLR  LDX     #13                    ;THERE ARE BETTER WAYS BUT THIS IS MOST
GETCHA    LDA     PLAYER                 ;BYTE EFFICIENT I THINK AND WE'RE NOT
          BEQ     BLAH                   ;CONCERNED ABOUT TIME HERE
          LDA     PLYTWTBL,X
          BNE     BLAH2                  ;THE ONLY ZERO CHARACTER IS ZERO
BLAH      LDA     PLYONTBL,X
BLAH2     STA     BOTMSMAP+3,X
          DEX
          BPL     GETCHA

          JSR     BCKSTART               ;START BACKGROUND TUNE

          LDA     #$16                   ;TURN ON PALETTE
          LDY     #$B6                   ;TURN OFF PALETTE
          LDX     PLAYER
          BNE     TWOISUP

          STA     DLY+3                  ;PLAYER ONE IS UP: TURN ON HIS SCORE
          STA     DLZ+3                  ;AND LIVES
          STY     DLY+13                 ;TURN OFF PLAYER TWO'S LIVES AND SCORE
          STY     DLZ+13
          RTS

TWOISUP   STA     DLY+13                 ;PLAYER TWO IS UP: TURN ON HIS SCORE
          STA     DLZ+13                 ;AND LIVES
          STY     DLY+3                  ;TURN OFF PLAYER ONE'S LIVES AND SCORE
          STY     DLZ+3
          RTS


INITAUTO  LDA     #L(ATOSTATE)
          STA     STATEPTR
          LDA     #H(ATOSTATE)
          STA     STATEPTR+1

          LDA     #38                    ;CENTER 'DESERT FALCON' IN BOTMSMAP
          STA     DLZ+9

          LDX     #12
GGJJ2     LDA     SPHTBL,X
          STA     BOTMSMAP+4,X
          DEX
          BPL     GGJJ2
          RTS


YFILL     DB      L(PL1MAP),$60,H(PL1MAP),$16,0
          DB      L(TOPMSMAP),$60,H(TOPMSMAP),$2C,40
          DB      L(PL2MAP),$60,H(PL2MAP),$16,120

ZFILL     DB      L(PL1LVMAP),$60,H(PL1LVMAP),$16,0
          DB      L(BOTMSMAP),$60,H(BOTMSMAP),$4C,40
          DB      L(PL2LVMAP),$60,H(PL2LVMAP),$16,120

DLTBL     DB      $4F,H(NULHDR),L(NULHDR),$C8,H(NULHDR),L(NULHDR)
          DB      $4F,H(DL0),L(DL0),$4F,H(DL1),L(DL1)
          DB      $4F,H(DL2),L(DL2),$4F,H(DL3),L(DL3),$4F,H(DL4),L(DL4)
          DB      $4F,H(DL5),L(DL5),$4F,H(DL6),L(DL6),$4F,H(DL7),L(DL7)
          DB      $4F,H(DL8),L(DL8),$4F,H(DL9),L(DL9),$4F,H(DL10),L(DL10)
          DB      $CF,H(DL11),L(DL11),$C0,H(NULHDR),L(NULHDR)
                  ;one blank line to clean up dma mess
          DB      $47,H(DLY),L(DLY),$47,H(DLZ),L(DLZ)
          DB      $CF,H(NULHDR),L(NULHDR),$46,H(NULHDR),L(NULHDR)

*         FOR PAL HACKING
*         DB      $4F,H(NULHDR),L(NULHDR),$4F,H(NULHDR),L(NULHDR)
*         DB      $4F,H(NULHDR),L(NULHDR),$4B,H(NULHDR),L(NULHDR)

          DB      $CF,H(NULHDR),L(NULHDR)


SPHTBL    DB      L(D),L(E),L(S),L(E),L(R),L(T),L(BLANKCHR),L(F),L(A),L(L),L(C)
          DB      L(O),L(N)

          END
*         SPHINX--SKERNEL.S

          ZERODEF

          RSEG    CODE9

***************   ALL DLI'S MUST START ON SAME PAGE!!!!!! ***********


*         DLITOP                         ;FIRST DLI TAKES PLACE AT TOP OF SCREEN
DLITOP                                   ;SAVE REGISTERS
          PHA                            ;A,X,Y USED
          TXA
          PHA
          TYA
          PHA

          LDA     #$50                   ;RESTORE CTRL TO ITS OWN STATE
          STA     CTRL

          LDA     P0C2SHAD               ;RESTUFF PALETTES FOR GAME SCREEN
          STA     P0C2                   ;SHOULD PROBABLY BE DONE WITH SHADOWS
          LDA     P1C2SHAD
          STA     P1C2                   ;5/25/84
          LDA     P2C2SHAD
          STA     P2C2
          LDA     P5C2SHAD               ;TO UNDO OTHER HACK JEM: 5/14/84
          STA     P5C2

          CLD                            ;RANDOM IS CALLED HERE, SO CLD
;         BIT     FUCKFLAG               ;PUT THESE BACK TO SEE IF LOADER IS
;         BPL     FINE                   ;INTERRUPTED BY THIS DLI
; GOTCHA  NOP
                                         ;REMEMBER THIS DLI HAPPENS EARLIER NOW!
FINE      LDA     DLZDEST                ;CHANGE DLIPTR
          STA     DLIPTR
          JSR     RANDOM                 ;RANDOM NUMBER GENERATOR
          STA     WSYNC
          LDA     BACKCOL                ;TURN ON BACKGROUND COLOR
          STA     BACKGRND

          BIT     FUCKFLAG
          BPL     DONTFUCK

          JSR     DOZEROS                ;PUT ZEROS AT END OF DISPLAY LISTS

DONTFUCK  PLA                            ;RESTORE REGISTERS
          TAY
          PLA
          TAX
          PLA
          RTI


*         DLIZ11                         ;THIS MUST BE DONE AT END OF ZONE10 TO
* SET CHARBASE FOR ZONE11.  POTENTIALLY A SHORT ZONE AND MAY BE FOLLOWED BY ONE
DLIZ11
          PHA
          LDA     D11CBASE
          STA     WSYNC                  ;WAIT UNTIL END OF ZONE 10
          STA     CHARBASE
          LDA     #L(DLIBOT)
                                         ;DMA SHOULD KICK IN HERE
          STA     DLIPTR                 ;NEED TO HAVE TIME TO DO THIS STORE
          PLA
          RTI


*         DLISNCTT        SYNCING DLI FOR TITLE PAGE
DLISNCTT
          PHA
          LDA     #L(DLITIT)
          JMP     SYNCSAME

*         DLISYNC         SYNCING DLI FOR REGULAR SCREEN
DLISYNC                                  ;THIS IS THE SYNCIN' DLI
          PHA                            ;ARE WE SURE THIS IS CORRECT??
          LDA     #L(DLITOP)
SYNCSAME  STA     WSYNC
          STA     WSYNC                  ;THIS SHOULD BE END OF KERNEL

          BIT     MSTAT
          BPL     UNSYNC                 ;PUNT IF IN KERNEL
          BIT     MSTAT
          BPL     UNSYNC

          STA     DLIPTR

UNSYNC
          PLA
          RTI


*         DLZ11A                         ;ALTRNTE. DLI HANDLER FOR 1 LINE ZONE11
DLZ11A
          PHA

          LDA     D11CBASE
          STA     WSYNC                  ;WSYNC TO FINISH ZONE 10
          STA     CHARBASE               ;NEW CHARBASE FOR ZONE 11


* THIS IS FUNCTIONALITY OF DLIBOT WHICH IS SKIPPED WHEN ZONE11 IS 1 HIGH
          LDA     #L(DLISYNC)
          STA     DLIPTR
          STA     WSYNC                  ;THIS SHOULD FINISH ZONE 11

          LDA     #H(CHARS)
          STA     CHARBASE               ;THIS IS CHARBASE FOR SCORE

          LDA     #$43
          STA     WSYNC

          STA     CTRL                   ;CTROL VALUE FOR 320 MODE

          LDA     #0                     ;BLACK BACKGROUND
          STA     BACKGRND

          JMP     NOWLOAD

*         DLITIT        TITLE PAGE DLI
DLITIT                                   ;ALL THESE REGISTERS MAY NOT HAVE TO
          PHA                            ;BE SAVED
          TXA
          PHA
          TYA
          PHA

          LDA     #H(TITCHR1)
          STA     CHARBASE

          LDA     #$50                   ;COMMENT
          STA     CTRL

          JSR     DOALLIO
          INC     FRMCNT
          BNE     SHITT
          INC     STATIMER

SHITT
          LDA     #L(DLITIT2)
          STA     DLIPTR
          LDA     #H(DLITIT2)
          STA     DLIPTR+1

          PLA
          TAY
          PLA
          TAX
          PLA
          RTI

*         DLITIT2                        ;SETS CHARBASE FOR CHAR FONT AT BOTTOM
DLITIT2                                  ;SECOND TITLE PAGE DLI
          PHA

          LDA     #H(CHARS)
          STA     CHARBASE

          LDA     #$43
          STA     CTRL

          LDA     #L(DLISNCTT)
          STA     DLIPTR
          LDA     #H(DLISNCTT)
          STA     DLIPTR+1

          PLA
          RTI

*         DLIBOT                         ;THIS MUST BE DONE IN DLI AT END OF
DLIBOT                                   ;REGULAR ZONES
          PHA
                                         ;DLI TO CHANGE BACKGROUND COLOR

          LDA     #H(CHARS)
          STA     CHARBASE
          STA     WSYNC                  ;THIS SHOULD FINISH ZONE 11

          LDA     #L(DLISYNC)
          STA     DLIPTR

          LDA     #$43                   ;CTRL FOR 320 MODE
          STA     WSYNC

          STA     CTRL

          LDA     #0                     ;BLACKGROUND
          STA     BACKGRND

NOWLOAD
*         COLOR CHANGES FOR BOTTOM OF SCREEN DISPLAY
          LDA     #$06                   ;THESE ARE HARDWIRED NOT THE ONES AT
          STA     P5C2                   ;TOP OF SCREEN
          LDA     P1C2SHDB               ;SHADOW NEEDED HERE
          STA     P1C2                   ;FOR TOPMSMAP
          LDA     #$3E
          STA     P2C2                   ;FOR BOTMSMAP
          LDA     #$EF
          STA     P0C2                   ;FOR SCORE AND XTRA LIVES

          TXA
          PHA
          TYA
          PHA

          CLD                            ;ONLY NEEDED FOR DLI'S WHICH ADD OR SUB

*         FREEZE FRAMER
FRZFRMR   BIT     FREEZEP
          BPL     DOTODO

          LDA     PERIOD
          BEQ     NOTHING

          DEC     NEXFRAME
          BNE     NOTHING

          STA     NEXFRAME

          LDX     HOWMANY
          BEQ     DOTODO
          DEX
          STX     HOWMANY
          BNE     DOTODO

          LDX     #0
          STX     PERIOD
          INX
          STX     NEXFRAME

DOTODO    INC     FRMCNT                 ;GO FOR FRMCNT
          BNE     BLAH
          INC     STATIMER               ;IT IS TWO BYTES

BLAH      DEC     SECOND                 ;SECOND COUNTER
          BPL     NOTSECND

          LDA     #59                    ;START NEXT SECOND
          STA     SECOND

          LDA     PHASE                  ;TIME THE BONUS RACK
          CMP     #-2
          BNE     NOTBONUS               ;NOT IN BONUS RACK

          SED
          LDA     BNSTIMER
          SEC
          SBC     #1
          STA     BNSTIMER
          CLD
          BNE     NOTBONUS               ;NOT DONE WITH BONUS

          JSR     LDTREAS                ;DISPLAY ZERO SECONDS

          DEC     PHASE                  ;GOTO FLASH PHASE
          LDA     #FLASHT0
          JSR     TUNIN
          LDA     #FLASHT1
          JSR     TUNIN

NOTBONUS  LDA     PTIMER                 ;POWER TIMER
          BEQ     NOTSECND

          DEC     PTIMER
          BNE     NOTSECND

          JSR     CLRPFLGS               ;CLEAR TIMED POWER FLAGS

NOTSECND  LDA     FRMCNT                 ;DISPATCH ON ODD OR EVEN
          LSR     A
          BCC     DOTUNE

DOLOAD    BIT     RUNLOAD
          BPL     DOTUNE
          JSR     SCROLL                 ;ON ODD, SCROL CMAPS AND RUN LOADER
          JSR     LOADER
          LDA     #0
          STA     RUNLOAD

DOTUNE    JSR     TUNER                  ;TUNE DRIVER
          JSR     RUNBACK                ;UPDATE BACKGROUND TUNE
          JSR     BACKON                 ;CHECK TO PUT ON BACKGOUND TUNE.  IF
                                         ;SO, SWAP IT IN

NOTHING
          JSR     DOALLIO

INTEROUT
          PLA                            ;RESTORE REGISTERS
          TAY
          PLA
          TAX
          PLA
          RTI

ZERO      EQU     0

DLIHSC0
          PHA
          TXA
          PHA
          TYA
          PHA
                                         ;DO COLORS, CHARBASE, AND CONTROL
          LDA     #H(TITCHR1)
          STA     CHARBASE

          LDA     #$50
          STA     CTRL

          LDA     #L(DLIHSC1)            ;SAME PAGE I HOPE
          STA     DLIPTR

          LDA     #$0F
          STA     P0C2

          LDA     #$3A
          STA     P1C2

          LDA     #$00
          STA     P2C2

          LDA     #$10
          STA     P3C2

          LDA     #$37
          STA     P4C2

          JSR     TUNER                  ;RUN THE TUNES

          PLA
          TAY
          PLA
          TAX
          PLA
          RTI

DLIHSC1
          PHA
          TXA
          PHA
          TYA
          PHA

          LDA     #L(DLIHSC0)
          STA     DLIPTR

          JSR     HSCSETRS               ;RESETS WAT'S REG'S

          JMP     INTEROUT

********************************************************************************
*                                                                              *
*                                  STARTUP                                     *
*                                                                              *
********************************************************************************

STARTUP   SEI                            ;HARDWARE DEPENDENT INITS
          CLD
;         LDA     #$07                   ;LOCK ME IN MARIA MODE
          LDA     #$87                   ;PUT THIS IN WHEN WE HAVE 2BUT HARDWARE
          STA     $1
          LDA     #0                     ;FOR FUTURE EXPANSION AND IMPERIALISM
          STA     OFFSET
          LDX     #$FF                   ;STACK POINTER AT $1FF

          TXS

          LDX     #$7F                   ;KEEP COLOR BURST ON
          STX     CTRL                   ;TURN OFF DMA

          LDY     #$FF                   ;zero out zero page
ZERLOOP
          CPY     #CTRL                  ;DON'T STORE TO CTRL AGAIN
          BEQ     NOSTOR                 ;TO AVOID TURNING ON DMA
          STA     ZERO,Y
NOSTOR    DEY
          BNE     ZERLOOP

          LDA     #0                     ;ENOUGH TIME HAS ELAPSED TO ALLOW CAPS
          STA     $1                     ;TO DISCHARGE SO CONTINUE FUCKING WITH
          LDA     #$14                   ;IO HARDWARE
          STA     CTLSWB
          LDA     #0                     ;SELECT TWO BUTTON MODE
          STA     SWCHB

          LDX     #$40                    ;POWER UP GETS THIS ONE
          LDA     #0
LEVEL1LP  STA     ZERO,X
          INX
          BNE     LEVEL1LP
          JSR     PREINIT                ;THIS SETS UP THE POWER UP DEFAULT
          JSR     INITIT
                                         ;MODES FOR THE GAME
          JMP     VBLNK

GAMEDO                                   ;RESETS GO TO HERE
          LDX     #FUTEXP1
          LDA     #0
LEVEL2LP  STA     ZERO,X
          INX
          BNE     LEVEL2LP
          JSR     TOTINIT
          JSR     MCPINIT                ;TAKEN OUT OF TOTINIT
          JSR     TOTINIT2
          BIT     GAMEU
          BPL     SHINIT
          JSR     INITGAME
          JMP     SHINIT

NEWPLYDO                                 ;AUTOPLAY GOES HERE
          LDX     #FUTEXP2
          LDA     #0
LEVEL3LP  STA     ZERO,X
          INX
          BNE     LEVEL3LP
          JSR     TOTINIT
          JSR     TOTINIT2
          BIT     TITLMENU               ;TITLMENU?
          BMI     CKPLR
          JSR     INITIT                 ;YES, JSR INITIT AND CONTINUE
          JMP     VBLNK
CKPLR     BIT     NEWPLYR
          BPL     ATOCK
          JSR     INITNPLR
          JMP     SHINIT
ATOCK     BIT     AUTOPLAY
          BPL     SHINIT
          JSR     INITAUTO
          JMP     SHINIT

SHINIT
VBLNK     BIT     MSTAT                  ;WAIT FOR V BLANK
          BPL     VBLNK
          BIT     MSTAT                  ;DO WE STILL NEED TWO OF THESE???
          BPL     VBLNK                  ;NO

          LDA     #$50                   ;FINALLY TURN ON DMA
          STA     CTRL

          BIT     NEWPLYR
          BMI     JFK

          LDA     #ALADIN1               ;START TUNE     THIS IS BULLSHIT
          JSR     TUNIN                  ;COMMENTED OUT CAUSE I CANT STAND IT
          LDA     #ALADIN0
          JSR     TUNIN

JFK       LDA     #0                     ;FLAGS JOB IS DONE SO RESET
          STA     NEWPLYR


MAINLOOP
          LDA     SWCHBIO                ;GET CURRENT STATE OF IO
          TAY                            ;TUCK SWCHBIO AWAY FOR NOW
          EOR     OLDSWCHB
          BEQ     CONTGAME               ;NO CHANGE IN IO SO BRANCH

*         CHANGE!  IS IT A RESET?
          LSR     A                      ;CHECK FOR CHANGE IN RESET
          BCC     PCHKSLCT               ;NO CHANGE SO CHECK SELECT
          LSR     OLDSWCHB               ;CHECK OLD RESET BIT IF ZERO
                                         ;THEN WE'VE GOT A RESET
          BCS     CHEKSLCT               ;OTHERWISE CHECK FOR SELECT
                                         ;CARRY CLEAR SO CHANGE IN RESET BIT
                                         ;& OLD VALUE OF ZERO INDICATES A RESET
GOTOGAME  LDX     #$7F                   ;DONT'T TURN OFF COLOR BURST
          STX     CTRL                   ;BUT DONT TURN OFF DMA
          LDX     #$FF
          STX     TITLMENU               ;TURN OFF TITLMENU FLAG
          STX     GAMEU                  ;TURN ON GAME FLAG
          INX
          STX     NEWPLYR                ;MAKE SURE NEWPLYR IS OFF
          STX     PAUSE                  ;TURN OFF ALL OTHER STATE FLAGS
          STX     HSC                    ;FOR SECURITY
          STX     AUTOPLAY
          STX     DMA
          STX     GAMEOVR
          STX     PLAYER                 ;PLAYER 1 IS FIRST
          JMP     GAMEDO

*         IS IT A SELECT?
PCHKSLCT  LSR     OLDSWCHB               ;ACCUM. HAS EOR OF SWCHB AND OLDSWCHB
CHEKSLCT  LSR     A                      ;CHECK FOR SELECT BIT
          BCC     PPAWS                  ;NO SELECT CHECK FOR PAUSE NEXT

          LSR     OLDSWCHB               ;POSSIBLE SELECT CHECK FOR 0 TO 1 TRANS
          BCC     MENOPAWS               ;1 TO 0 TRANSITION SO IGNORE
                                         ;LOOKS LIKE A SELECT TO ME
          BIT     TITLMENU               ;BUT ARE WE ALREADY IN TIT PGE. IF SO
          BPL     MENOPAWS               ;PUNT

GOTOTIT   LDX     #0
          STX     STATIMER               ;RESET STATIMER
          STX     GAMEU                  ;TURN OFF GAME IF ON
          STX     NEWPLYR                ;TURN OFF NEWPLYR
          STX     TITLMENU               ;TURN ON TITLMENU
          STX     AUTOPLAY               ;TURN OFF AUTOPLAY
          STX     DMA                    ;TURN OFF DMA FLAG
          STX     GAMEOVR                ;TURN OFF GAME OVER FLAG IF SET

NEWPLR    LDX     #$7F                   ;SWITCH PLAYERS BUT
          STX     CTRL
          LDX     #$FF
          TXS                            ;THIS IS PROBABLY NOT NECESSARY
          JMP     NEWPLYDO               ;GO TO TITLE PAGE

PPAWS     LSR     OLDSWCHB
MENOPAWS  LSR     A                      ;THIS JUST SETS A FLAG WHICH GAME LOOKS
          LSR     A                      ;AT.  SHIFT TO CHECK PAUSE BIT
          BCC     CONTGAME

          LSR     OLDSWCHB               ;CHECK TO SEE IF OLD VALUE IS LOW
          LSR     OLDSWCHB
          BCS     CONTGAME               ;NOT LOW SO PUNT

          LDA     #$FF                   ;PAUSE BUTTON HAS BEEN PRESSED
          STA     PAWSTWID

CONTGAME  STY     OLDSWCHB
          JMP     (STATEPTR)             ;JUMP TO APPROPRIATE STATE


*         GAME STATE
GAMSTATE  BIT     GAMEOVR                ;IF OVER BOOGIE ON TO TITLE PAGE
          BPL     NOGOTIT

          LDX     #$7F                   ;WHO THE FUCK KNOWS ANYWAY
          STX     CTRL
          JSR     HSPOWNIT
          JSR     HSGAMOVR
          JMP     GOTOTIT

NOGOTIT   BIT     NEWPLYR                ;IF NOT OVER BUT NEW PLAYER RESET
          BMI     NEWPLR

          BIT     PAWSTWID
          BPL     JPDOGAME
                                         ;SET UP PAUSE STATE
          LDX     #$FF
          STX     FREEZEP                ;TURN ON FREEZE FRAME
          LDA     #L(PSESTATE)           ;INITIALIZE POINTER TO PAUSE
          STA     STATEPTR
          LDA     #H(PSESTATE)
          STA     STATEPTR+1
          INX
          STX     GAMEU                  ;TURN OFF GAME FLAG
          STX     PAWSTWID               ;TURN OFF PAUSE TWIDDLE
          STX     AUDV0                  ;KILL SOUNDS
          STX     AUDV1                  ;TUNER NEVER CALLED WHEN IN FREEZE MODE
          JMP     MAINLOOP

JPDOGAME  JMP     DOGAME


*         PAUSE STATE
PSESTATE
          BIT     PAWSTWID
          BPL     JMNLP                  ;PAUSE TWIDDLE NOT SET SO JMP MAINLOOP

          LDX     #$FF                   ;GO BACK TO GAME STATE
          STX     GAMEU

          INX
          STX     PAWSTWID
          STX     FREEZEP                ;TURN OFF FREEZE FRAMER
          STX     PAUSE                  ;TURN OFF PAUSE
          LDA     #L(GAMSTATE)           ;INITIALIZE POINTER FOR GAME STATE
          STA     STATEPTR
          LDA     #H(GAMSTATE)
          STA     STATEPTR+1
JMNLP     JMP     MAINLOOP


*         TIT STATE
TITSTATE                                 ;ONLY DO IT ONCE A FRAME???
          LDA     FRMCNT
          CMP     TITCNT
          BEQ     JMNLP

          LDA     FRMCNT
          STA     TITCNT

          DEC     OTIMER                 ;HAVE WE WAITED AFTER INITIAL START
          BNE     JMNLP                  ;OF TITLE PAGE

          LDA     #1                     ;HACK TO DEACTIVATE OTIMER
          STA     OTIMER

          BIT     LEFTBUT                ;CHECK FOR TRIGGER RESET
          BMI     SLDKFJ

          JMP     GOTOGAME               ;BUTTON PRESSED, SO RESET TO GAME MODE

SLDKFJ    LDA     SWCHA                  ;ANY PLAYER ONE JOYSTICK INPUT RESET
          AND     #$F0                   ;TIMER
          CMP     #$F0
          BEQ     NOTIMRST
          LDA     #0
          STA     STATIMER

NOTIMRST  LDA     SWCHB                  ;IS SELECT DEPRESSED?
          AND     #$02
          BEQ     CHKSTIM                ;YES, BRANCH

          LDA     #$80                   ;NO MAKE SURE TIMER ISN'T STARTED
          STA     STIMER
          BMI     DIFFCHK                ;AND CONTINUE TO OTHER CODE

CHKSTIM   LDA     #0                     ;IO HAS OCCURRED SO RESET TIT. PGE TIMR
          STA     STATIMER

          LDA     #$80                   ;BLOW OTHER TIMERS OUT OF THE WATER
          STA     ETIMER                 ;SELECT SWITCH HAS PRIORITY OVER
          STA     WTIMER                 ;JOYSTICK

          BIT     STIMER                 ;HAS TIMER BEEN SET?
          BMI     CHGSETNG               ;NO SO GO AHEAD AND CHANGE SETTING

          DEC     STIMER                 ;TIMER IS SET SO DECREMENT IT
          BNE     JMNLP                  ;PUNT IF NOT AT ZERO

CHGSETNG  INC     DIFCULTY               ;CYCLE THROUGH DIFFICULTIES
          LDA     DIFCULTY
          AND     #$03
          STA     DIFCULTY
          BNE     TWIDIL
          LDA     NUMPLYRS
          EOR     #$03
          STA     NUMPLYRS
          JSR     PLAYTWID
TWIDIL    JSR     DIFFTWID
          LDA     #35
          STA     STIMER
          JMP     MAINLOOP

DIFFCHK   LDA     SWCHA
          AND     #$80                   ;CHECK EAST BIT
          BEQ     CHKETIM                ;YES

          LDA     #$80                   ;NO, SO ENABLE EAST MOVEMENT
          STA     ETIMER
          BMI     CHKWEST

CHKETIM   BIT     ETIMER                 ;IS EAST MOVEMENT ENABLED?
          BMI     INCDIFF                ;YES SO INC DIFFICULTY

          DEC     ETIMER                 ;NOT ENABLED SO WE MUST COUNT DOWN
          BNE     CHKWEST                ;AND THEN GO AWAY

INCDIFF   INC     DIFCULTY               ;INCREMENT DIFFICULTY LEVEL
          LDA     DIFCULTY
          AND     #$03
          STA     DIFCULTY               ;WRAPAROUND
          JSR     DIFFTWID
          LDA     #35
          STA     ETIMER                 ;DISABLE EAST MOVEMENT AND SET TIMRE

CHKWEST   LDA     SWCHA
          AND     #$40
          BEQ     CHKWTIM

          LDA     #$80
          STA     WTIMER
          BMI     SELCHK

CHKWTIM   BIT     WTIMER
          BMI     DECDIFF

          DEC     WTIMER
          BNE     SELCHK

DECDIFF   DEC     DIFCULTY
          LDA     DIFCULTY
          AND     #$03
          STA     DIFCULTY
          JSR     DIFFTWID
          LDA     #35
          STA     WTIMER

SELCHK    LDA     SWCHA                  ;CHECK NORTH BIT FOR NUMBER OF PLAYERS
          AND     #$F0
          CMP     #$E0                   ;SELECT
          BNE     CHKSOUTH

          LDX     #2
          STX     NUMPLYRS               ;TWO PLAYERS
          JSR     PLAYTWID

          JMP     TIMCHK

CHKSOUTH                                 ;A STILL HAD SWCHA AND F0
          CMP     #$D0                   ;CHECK SOUTH BIT
          BNE     TIMCHK                 ;ACCUMULATOR STILL SET FROM LDA ABOVE

          LDX     #1
          STX     NUMPLYRS               ;SET NUMBER OF PLAYERS TO ONE
          JSR     PLAYTWID

TIMCHK    LDA     STATIMER               ;CHECK FOR TIMEOUT
          CMP     #4
          BNE     MJMP

          LDX     #$7F                   ;DONT' TURN OFF COLOR BURST
          STX     CTRL                   ;BUT TURN OFF DMA

          JSR     HSPOWNIT
          JSR     HSDISP                 ;DO HIGH SCORE CART DISPLAY

          LDX     #$7F                   ;WHEN IN DOUBT TURN OFF CTRL
          STX     CTRL

          LDX     #$FF
          TXS
          STX     TITLMENU               ;TURN OFF TITLEMENU
          STX     AUTOPLAY               ;TURN ON AUTOPLAY
          INX
          STX     STATIMER               ;CLEAR TIMING FLAG
          JMP     NEWPLYDO

MJMP      JMP     MAINLOOP


*         AUTOPLAY STATE
ATOSTATE  BIT     LEFTBUT                ;CHECK FOR TRIGGER RESTART
          BMI     TIMCHKA

          JMP     GOTOGAME               ;GO TO GAME STATE TRIGGER PRESSED

TIMCHKA   LDA     STATIMER               ;MORE TIMEOUT CHECKS
          CMP     #5
          BNE     CHKSTK

GOTOSEL   JMP     GOTOTIT                ;DON'T TURN OFF COLOR

CHKSTK    LDA     SWCHA                  ;CHECK FOR SELECT
          AND     #$F0
          CMP     #$F0
          BNE     GOTOSEL


*         HSC STATE
HSCSTATE                                 ;NOT IMPLEMENTED YET

DOGAME    LDA     FRMCNT                 ;MAIN LOOP
          SEC
          SBC     OLDFRM
          CMP     #2                     ;ONLY EXECUTE EVERY OTHER FRAME
          BCS     DOALL
          JSR     RANDOM                 ;DO RANDOM IF NOTHING LEFT TO DO
          JMP     MAINLOOP
DOALL     LDA     FRMCNT                 ;THIS IS THE MAMA LOOP
          STA     OLDFRM

          INC     MAINCNT
          BNE     DOALL1
          LDX     PLAYER
;         INC     GAMETIME,X
DOALL1
          BIT     RUNLOAD
          BMI     DOALL1

          LDA     PHASE
          BPL     NOFLASH
          CMP     #-2
          BCC     FLASH                  ;FLASH STARTS AT -3

NOFLASH   JSR     VSCRP
          LDA     #$80
          STA     RUNLOAD
          JSR     ENEMYMCP               ;MCP FOR NON-SCROLL RELATED ENEMIES
          JSR     GRNDMCP                ;CALL MCP FOR SCROLLING COUPLED ENEMIES
          JSR     GAME                   ;BIRD AND SHOT DRIVER AND OTHER THINGS
          JSR     ANIMFLEA               ;FLEA DRIVER
          JSR     UWEANIM                ;UWE DRIVER
          JSR     SCRLOAD
          JSR     DOMINIS
          JSR     DOSPHINX
          JSR     DOSXSHTS
          JSR     DOFIRE
          JSR     DOHIEROS
          JSR     NEWBLOCK
          JSR     LDSCORE                ;LOAD SCORE DISPLAY
          JSR     LDLIVES                ;LOAD LIVES DISPLAY
          JSR     LDTREAS                ;LOADS TREASURE DISPLAY

          JSR     LDHIEROS               ;LOAD HEIROGLYPH DISPLAY
*         JSR     LDPOWER                ;LOAD POWER DISPLAY
*****
          LDA     #0
          STA     GSCRFLAG
          STA     GCOARSE
          JMP     MAINLOOP               ;AND AGAIN AND AGAIN

** FLASH COLORS ON THE SCREEN **
FLASH     DEC     PHASE
          LDA     PHASE
          CMP     #-60                   ;TIME THE FLASH
          BNE     CCFL0

          LDX     PLAYER
          INC     RACK,X

          LDA     #0
          STA     SVDIST,X
          STA     SVDIST+2,X
          STA     SVHDIST,X
          STA     SVHDIST+2,X

          LDA     #$FF
          STA     NEWPLYR

          JSR     ENDBONUS

          LDA     #0
          STA     PHASE

          JMP     MAINLOOP

* SET RANDOM COLORS INTO ALL PALLETTES *
CCFL0     LDX     #$1F
CCFL1
          JSR     RANDOM
          STA     BACKGRND,X
CCFL2     DEX
          BMI     FNOMORE
          TXA
          AND     #3
          BNE     CCFL1
          BEQ     CCFL2
FNOMORE
          JSR     RANDOM
          STA     BACKCOL

          JMP     MAINLOOP


RANDOM    ADC     FRMCNT                 ;RANDOM NUMBER GENERATOR
          ADC     RNDOM
          ADC     RNDOM1
          PHA
          LDA     RNDOM
          STA     RNDOM1
          PLA
          STA     RNDOM
          RTS

*         DOALLIO         MAPS HARDWARE FIREBUTTON INTO SOFTWARE REGS. SAME FOR
* SWCHB.  COMPLEMENTS OF ETHAN
DOALLIO
          LDA     SWCHA                  ;FOR TRIGGERING BREAKPOINTS.  WILL BE
                                         ;MADE INTO MECHANISM TO STUFF SOFTWARE
                                         ;REGISTERS
          LDA     SWCHB                  ;GET SWCHB FOR RESETS AND SUCH
          AND     #$0B
          STA     SWCHBIO

CKJOY     LDX     #1                     ;DO PLAYERS 1 AND 0
ZNXTRJ    JSR     READJOY                ;READ HIS JOYSTICK
          DEX
          BPL     ZNXTRJ
          RTS

* READJOY: READ JOYSTICK/BUTTONS.  ON ENTRY X = PLAYER.  Y GETS TRASHED
READJOY   LDY     INPT4,X
          BPL     GOTONE                 ;IF BIT 7 IS LO, OLD-STYLE BUTTON HIT

          LDA     ONEBUT                 ;ARE WE ALREADY IN OLD-STYLE MODE?
          AND     RJBITS,X
          BNE     GOTONE2                ;YES.  GO RIGHT TO ONE-BUTTON HANDLER.

          TXA                            ;OTHERWISE, COMPUTE INDEX INTO
          ASL     A                      ; PADDLE PORTS, FOR PLAYER X,
          TAY                            ; IN Y (X * 2)

          LDA     INPT4L,Y               ;READ LEFT BUTTON
          EOR     #$FF                   ;INVERT SENSE
          STA     LEFTBUT,X
          LDA     INPT4R,Y               ; RIGHT BUTTON
          EOR     #$FF                   ;INVERT SENSE
RJSTORE   STA     RIGHTBUT,X

RJRTS     RTS

          ;HERE ON OLD-STYLE SINGLE BUTTON JOYSTICK PRESS.
GOTONE    LDA     ONEBUT                 ;SET ONE-BUTTON MODE IMMEDIATELY
          ORA     RJBITS,X               ; TO AVOID DESTROYING HARDWARE!
          STA     SWCHB
          STA     ONEBUT                 ;UPDATE ONE BUTTON FLAG BYTE

          ;HERE ON ANY OLD-STYLE JOYSTICK, WHETHER PRESSED OR NOT
GOTONE2   TYA
          STA     LEFTBUT,X              ; (Y CONTAINS CURRENT VALUE OF INPT4)
          STA     RIGHTBUT,X             ;CLEAR RIGHT BUTTON COPY

          RTS

RJBITS    DB      $04,$10                ;MASK OF "ONE-BUTTON" BITS PER PLAYER
          RTS


*         PUT ZEROS AT THE END OF EACH DISPLAY LIST

DOZEROS   TXA
          PHA
          TYA
          PHA

          LDA     #0                     ;STORE ZEROES AT END OF DLISTS
          TAX                            ;TRADE ROM FOR TIME
          LDY     #1                     ;TWO ZEROS EACH
          STA     (ZNDLPOS,X)
          STA     (ZNDLPOS),Y
          STA     (ZNDLPOS+2,X)
          STA     (ZNDLPOS+2),Y
          STA     (ZNDLPOS+4,X)
          STA     (ZNDLPOS+4),Y
          STA     (ZNDLPOS+6,X)
          STA     (ZNDLPOS+6),Y
          STA     (ZNDLPOS+8,X)
          STA     (ZNDLPOS+8),Y
          STA     (ZNDLPOS+10,X)
          STA     (ZNDLPOS+10),Y
          STA     (ZNDLPOS+12,X)
          STA     (ZNDLPOS+12),Y
          STA     (ZNDLPOS+14,X)
          STA     (ZNDLPOS+14),Y
          STA     (ZNDLPOS+16,X)
          STA     (ZNDLPOS+16),Y
          STA     (ZNDLPOS+18,X)
          STA     (ZNDLPOS+18),Y
          STA     (ZNDLPOS+20,X)
          STA     (ZNDLPOS+20),Y
          STA     (ZNDLPOS+22,X)
          STA     (ZNDLPOS+22),Y

          PLA
          TAY
          PLA
          TAX
          RTS

          END
*         NILE FLYER - ALIAS SPHINX - SENEMIES
* MAY 8 VERSION.  PROGRAMMING NEW FLEAS.
* NO NEED FOR SHADOWS TO HAVE X,Y AND Z


          ZERODEF

          RSEG    CODEF

NFLS      EQU     8                      ; POSSIBLE NUMBER OF FLEAS
NFL2      EQU     $0F                    ; TWICE NUMBER OF FLEAS
SCRWID    EQU     160                    ; HPOS SCREEN WIDTH
FLEXPL    EQU     8                      ; START OF NON EXPLODING FLEAS

*** FOR FLEA MOVEMENT ***
FLYHI     EQU     $2E
FLYLO     EQU     $06
FLXHI     EQU     $78
FLXLO     EQU     $38

* POSITION INITIALIZATIONS *
XSTARTS   DB      $39,$3D,$41,$47,$4D,$50,$54,$57
          DB      $5D,$60,$65,$69,$6B,$6E,$72,$76
YSTARTS   DB      $07,$09,$0B,$0F,$12,$14,$16,$19
          DB      $1B,$1D,$20,$23,$26,$28,$2A,$2D
ZSTART    EQU     210

************************************************************

*         ENEMY INITIALIZER
* THIS ROUTINE INITIALIZES X,Y,Z,SM,SH,SL AND PW FOR THE GLIDERS AND THE
* SHADOWS.  THE DRIVER ACTUALLY INSERTS THE OBJECT WHEN IT IS TIME.

FLEAINIT                                 ;CLASS IS ALREADY LOADED
          JSR     RANDOM
          AND     #$0F                   ;RANDOM # <= 15
          TAX
          LDA     XSTARTS,X              ;GET RANDOM XSTART POSITION
          STA     SPNX                   ;PUSH X COORD
          JSR     RANDOM                 ;37
          AND     #$0F                   ;<=15
          TAX
          LDA     YSTARTS,X              ;GET RANDOM Y POSTION
          STA     SPNY                   ;PUSH Y COORD
          LDA     #ZSTART
          STA     SPNZ                   ;PUSH Z COORD
          JSR     SPAWN
          RTS

** SPAWN A NEW FLYING ENEMY (FLEA) **
ZSHADPW   EQU     $3D                    ;PW FOR SHADOWS

SPAWN
          STY     TEMP0                  ;SAVE X,Y REGISTERS
          STX     TEMP1

** RETURN IN Y THE INDEX OF AN AVAIL FLEA **
          LDY     #NFLS-1
FLOOP     LDA     FLEASTAT,Y             ;CHECK FOR AVAIL FLEA
          ORA     FLEASTAT+NFLS,Y
          BEQ     HAVEY
          DEY
          BPL     FLOOP
ERROR1    LDY     TEMP0   ; THIS WAS A TRAP      ;NO AVAILABLE FLEAS
          RTS
HAVEY
* PLAY A TUNE *
          LDA     #SPTUNE
          JSR     TUNIN

* Y NOW CONTAINS NEW FLEA INDEX (0-7) *
          LDA     #3                     ;INITIALLY MAKE IT OFF SCREEN
          STA     FLEASTAT,Y
          STA     FLEASTAT+NFLS,Y
          LDA     #FLEACOL
          STA     COLSTAT+FLEADEX,Y

          DEC     NUMFLEAS               ;DEC NUM OF AVAIL FLYING ENEMIES

* INITIALIZE FLEA TARGET *
          LDX     SPNCLASS               ;X = CLASS

          LDA     TARLOAD,X
          STA     FLEACNT,Y              ;INIT MT PROG COUNTER
          LDA     #0
          STA     FXRUN,Y                ;INIT X VELOCITY
          LDA     #0
          STA     FYRUN,Y                ;INIT Y VELOCITY
          JSR     RANDOM
          ORA     #$FE
          STA     FZRUN,Y                ;INIT Z VELOCITY
          LDA     TARPW,X                ;LOAD PALETTE WIDTH BYTE
          STA     PWTBL+FLEADEX,Y
          LDA     #ZSHADPW               ;LOAD SHADOW PALETTE WIDTH
          STA     PWTBL+FLSHDEX,Y
          LDA     TARTYPE,X              ;LOAD FLEA TYPE (0 GL, 1 SC, ETC)
          STA     FLEATYPE,Y
          TAX                            ;X = TYPE OF FLEA
** X NOW CONTAINS TYPE OF FLEA **

** SET POSITION OF FLEA **
* ZCOORD *
          LDA     SPNZ
          STA     ZTBL+FLEADEX,Y         ;Z STORED
          STA     ZTBL+FLSHDEX,Y         ;Z STORED FOR SHADOW
          SEC
          SBC     FCOLDZ1,X
          STA     COLZ1+FLEADEX,Y        ;STUFF COLZ1
          CLC
          ADC     FCOLDZ2,X
          STA     COLZ2+FLEADEX,Y        ;STUFF COLZ2

* Y COORD *
          LDA     #0
          STA     YTBL+FLSHDEX,Y         ;Y STORED FOR SHADOW
          LDA     SPNY
          STA     YTBL+FLEADEX,Y         ;Y STORED
          SEC
          SBC     FCOLDY1,X
          STA     COLY1+FLEADEX,Y        ;STUFF COLY1
          CLC
          ADC     FCOLDY2,X
          STA     COLY2+FLEADEX,Y        ;STUFF COLY2

* XCOORD *
          LDA     SPNX
          STA     XTBL+FLEADEX,Y         ;X STORED
          STA     XTBL+FLSHDEX,Y         ;X STORED FOR SHADOW
          SEC
          SBC     FCOLDX1,X
          STA     COLX1+FLEADEX,Y        ;STUFF COLX1
          CLC
          ADC     FCOLDX2,X
          STA     COLX2+FLEADEX,Y        ;STUFF COLX2

* X CONTAINS TYPE (0-3) *
* Y CONTAINS FLEA INDEX (0-7) *

* INITIALIZE FLEA ANIMATION *
          LDA     FLIFTBL,X              ;LOAD INITIAL FRAME FOR THIS TYPE
          STA     FLEANIM,Y
          TAX
          LDA     FLSHAPES,X             ;LOAD IN ANIMATION NUMBER OF FRAME
          TAX
          LDA     FLSHPTBL-1,X           ;LOAD IN SHAPE
          STA     SLTBL+FLEADEX,Y
          LDA     FLSHDTBL-1,X           ;LOAD IN SHADOW
          STA     SLTBL+FLSHDEX,Y
          LDA     #H(UNFOLD0)            ;LOAD HI BYTE OF INIT SHAPE
          STA     SHTBL+FLEADEX,Y
          STA     SHTBL+FLSHDEX,Y
          LDA     #H(UNFOLD0-$1600+$1700) ;LOAD 16 TALL
                                         ;SM:=SH-#ZNUMLINS+17 OBJ IS NOW 16 TALL
          STA     SMTBL+FLEADEX,Y
          STA     SMTBL+FLSHDEX,Y

          LDY     TEMP0
          LDX     TEMP1
          RTS



*         ENEMY DRIVER
*CHECKS SCREEN BOUNDS, INSERTS, DELETES AND
* MOVES OBJECTS ON SCREEN

FLITBL    DB      FLEADEX,FLEADEX+1,FLEADEX+2,FLEADEX+3
          DB      FLEADEX+4,FLEADEX+5,FLEADEX+6,FLEADEX+7
          DB      FLSHDEX,FLSHDEX+1,FLSHDEX+2,FLSHDEX+3
          DB      FLSHDEX+4,FLSHDEX+5,FLSHDEX+6,FLSHDEX+7

ANIMFLEA
          JSR     ADVFRMS                ;ADVANCE THE FRAMES
          JSR     MOVEFLEA

* CHECK FOR COLLISIONS *
          LDY     #NFLS-1
MVDETCOL
          LDA     FLEASTAT,Y
          CMP     #1                     ;SHOULD FIX STUCK FLEA
          BEQ     MVDETC1
          BNE     MVEND
MVDETC1   LDA     COLSTAT+FLEADEX,Y
          BEQ     MVEND                  ;ALREADY EXPLODING
          JSR     FLEADET                ;CHECK FOR COLLISION
MVEND     DEY
          BPL     MVDETCOL

*** MOVE ONTO, AROUND OR OFF OF SCREEN ***
          LDY     #NFL2                  ;SIXTEEN OBJECTS TOTAL
FSCRLOOP
          LDA     FLEASTAT,Y             ;INSPECT FLAG
          BEQ     NEXTONE                ;IF ZERO TRY NEXT FLEA/SHADOW

          LDA     FLITBL,Y
          TAX                            ;PUT REAL INDEX IN X

          LDA     FLEASTAT,Y             ;LOAD SCREEN STATE OF FLEA
          CMP     #1
          BEQ     ONSCREEN
          CMP     #3                     ;<> 3 ==> ON SCREEN
TRAP      BNE     TRAP

** PRESCREEN DRIVER **
          JSR     HPDO                   ;HORIZ POSITION
          CMP     #SCRWID+8              ;IF HP>172 THEN PUNT
          BCS     NEXTONE
          STA     HPTBL,X                ;OK TO STORE TO HPTBL

          JSR     VPDO                   ;VERTICAL POSITION
          CMP     #-12                   ;EMPIRICALLY DETERMINED. BOO HOO
          BCS     BRINGON                ;IF BETWEEN -12 AND SCREEN BOTTOM
          CMP     #SCRENBOT              ;THEN BRING FLEA ON SCREEN
          BCS     NEXTONE
BRINGON   STA     VPTBL,X                ;ELSE STORE VP AND BRING ON

** INSERT OBJECT WITH A CERTAIN PRIORITY **
          CPY     #NFLS
          STY     TEMPY
          BCC     NOTSHAD                ;HANDLE SHADOWS DIFFERENTLY

          LDA     #$FE                   ;SHADOW GETS PRIORITY OF $FE
          STA     TEMP6
          STA     TEMP10
          BCS     ISHAD

NOTSHAD   JSR     DXDO                   ;CALCULATE DX OF OBJECT TO BE INSERTED
ISHAD     JSR     OBJINS
          LDY     TEMPY
          LDA     #1                     ;SET FLAG TO 1 TO SIGNAL ONSCREEN
          STA     FLEASTAT,Y

** GO FOR THE NEXT FLEA **
NEXTONE   DEY                            ;NEXT ENEMY AND/OR SHADOW
          BPL     FSCRLOOP

;         JSR     LISTEST                ;MARK THOSE ELEMENTS
 ;        LDX     #NFL2
; STATLIST  LDY     FLITBL,X
  ;       LDA     TESTLIST,Y
   ;      BNE     INLIST
    ;     LDA     FLEASTAT,X
     ;    CMP     #1
      ;   BEQ     ATWAP
; INLIST    DEX
  ;       BPL     STATLIST

          RTS

; ATWAP     BEQ     ATWAP

** ONSCREEN DRIVER **
ONSCREEN
          JSR     HPDO                   ;CALCULATE HP
          STA     HPTBL,X
          CMP     #$F4
          BCS     KEEPGOIN
          CMP     #SCRWID+12             ;WHEN HPOS+12 = 0 THEN DELETE
          BCS     GETRID
KEEPGOIN
          JSR     VPDO                   ;CALCULATE VP
          STA     VPTBL,X
          CMP     #-40                   ;IF BETWEEN -40 AND SCREEN BOTTOM
          BCS     FLOBJMV                ;THEN MOVE OBJECT
          CMP     #SCRENBOT
          BCC     FLOBJMV

** REMOVE A FLEA OR SHADOW FROM THE SCREEN **
GETRID                                   ;ELSE PUNT OBJECT
          JSR     OBJDEL
                                         ;RECALL FLEA/SHAD INDEX
          LDA     #0
          STA     FLEASTAT,Y             ;CLEAR SCREEN STATUS
          CPY     #NFLS                  ;IF SHADOW
          BCS     CHCH                   ;GO CHECK FLEA
          STA     COLSTAT+FLEADEX,Y      ;DELETE FLEA FROM COLLISON TABLES
          LDA     FLEASTAT+NFLS,Y        ;CHECK SHADOW
          BNE     NEXTONE                ;STAT  IF ALSO ZERO THEN DEC NUMSCABS

INCNUM    INC     NUMFLEAS
          BPL     NEXTONE                ;JMP

CHCH      LDA     FLEASTAT-NFLS,Y        ;LOAD STATUS OF FLEA
          BEQ     INCNUM                 ;IF ALSO ZERO THEN INC NUMFLEAS
          BNE     NEXTONE                ;ELSE NEXT MOVE

** DO AN OBJECT MOVE ON A FLEA **
FLOBJMV   CPY     #NFLS
          BCS     NEXTONE                ;IF SHADOW NO NEED TO DO AN OBJECT MOVE
          STY     TEMPY
          JSR     DXDO                   ;UPDATE DX
          JSR     OBJMOV                 ;MOVE IN LINKED LIST
          LDY     TEMPY
          JMP     NEXTONE


**        HPDO: HP CALCULATE ROUTINE     **
HPDO      LDA     XTBL,X
          CLC
          ADC     ZTBL,X
          SBC     #NUMBER                ;SUBTRACT THE MAGIC NUMBER
;         ADC     HPDOTBL,Y
          RTS
;HPDOTBL   DB      L(0-NUMBER),L(-1-NUMBER) ;GLID,SCAB HP CONSTANTS

**        VPD0  VP CALCULATE ROUTINE     **
VPDO      LDA     XTBL,X
          SEC
          SBC     YTBL,X
          SBC     ZTBL,X
          CLC
          ADC     #NUMBER-13
;         ADC     VPDOTBL,Y
          RTS
;VPDOTBL   DB      -14+NUMBER,-13+NUMBER  ;GLID,SCAB VP CONSTANTS

**        DXDO: DX CALCULATE ROUTINE     **
DXDO      LDA     ZTBL,X
          SEC
          SBC     XTBL,X
          CLC
          ADC     #NUMBER+13+DXADJ
;         ADC     DXDFTBL,Y              ; THIS IS DF
          STA     TEMP10
          SEC
          SBC     #18
;         SBC     DXDCTBL,Y                ; THIS IS DC
          STA     TEMP6
          RTS

;DXDFTBL   DB      NUMBER+13+DXADJ        ;GLIDER DISP FAR CONST
;          DB      NUMBER+10+DXADJ        ;SCARAB FAR CONST
;DXDCTBL   DB      18,12                  ;DISPLAY CLOSE CONST


** ANIMATE THE ENEMIES - ADVANCE FRAMES **
ADVFRMS
          LDY     #NFLS-1                ;EIGHT ENEMIES
ANIMLOOP  LDA     FLEASTAT,Y
          BEQ     NEXTAN                 ;OFF SCREEN ALREADY SO PUNT
          CMP     #3
          BEQ     NEXTAN                 ;NOT ON SCREEN YET SO PUNT
          LDX     FLEANIM,Y
          LDA     FLSHAPES,X
          BEQ     KLFLEA
          BPL     ADV1
          AND     #$7F
          TAX
          LDA     FLSHAPES,X
ADV1
          INX
          STX     FLEANIM,Y
          TAX
          LDA     FLSHPTBL-1,X
          STA     SLTBL+FLEADEX,Y
          LDA     FLSHDTBL-1,X
          STA     SLTBL+FLSHDEX,Y
          LDA     FLEANIM,Y
          JMP     NEXTAN

KLFLEA
          LDX     FLITBL,Y               ;LOAD REAL INDEX
          JSR     OBJDEL                 ;AND DELETE FLEA
          LDA     #0                     ;ZERO OUT FLEASTAT
          STA     FLEASTAT,Y
          LDX     FLITBL+NFLS,Y          ;AND ITS SHADOW
          LDA     FLEASTAT+NFLS,Y
          BEQ     KLFLEA1
          JSR     OBJDEL
          LDA     #0
          STA     FLEASTAT+NFLS,Y
KLFLEA1   INC     NUMFLEAS               ;ONE LESS FLEA

NEXTAN    DEY
          BPL     ANIMLOOP
          RTS

* FLEA EXPLOSION TUNES *
FLTUNE
          DB      GLDEXPL
          DB      SCBEXPL
          DB      GLDEXPL
          DB      SCBEXPL

* INITIAL FRAME INDEX *
FLIFTBL
          DB      $00                    ;GLIDER
          DB      $0C                    ;SCARAB
          DB      $18                    ;PING
          DB      $22                    ;NEUFY

* COLDATA - COLX1,X2,COLY1,Y2,COLZ1,Z2  BY TYPE *
FCOLDX1   DB      5,4,3,5
FCOLDX2   DB      10,8,6,10
FCOLDY1   DB      2,3,3,3
FCOLDY2   DB      5,7,6,7
FCOLDZ1   DB      2,2,2,2
FCOLDZ2   DB      8,8,8,10

* EXPLOSION FRAME INDEX *
FXITBL
          DB      $0F                    ;GLIDER
          DB      $12                    ;SCARAB
          DB      $1D                    ;PING
          DB      $25                    ;NEUFY

* POINT VALUE OF FLEAS *
FLSCORE
          DB      $1                     ;GLIDER
          DB      $3                     ;SCARAB
          DB      $2                     ;PING
          DB      $5                     ;NEUFY

* ANIMATION SEQUENCES *
FLSHAPES
          DB      $0B                    ;0    FOLDED GLIDER
          DB      $80                    ;GOTO 0
          DB      $0A,$0A,$0A,$0A
          DB      $09,$09,$09,$09
          DB      $08                    ;A   GLIDER
          DB      $8A                    ;GOTO A
          DB      $0C                    ;C   BUZZING SCARAB
          DB      $0D
          DB      $8C                    ;GOTO C
          DB      $07                    ;F   EXPLODING GLIDER
          DB      $06
          DB      $94                    ;GOTO 14
          DB      $05                         EXPLODING SCARAB
          DB      $04
          DB      $03                    ;14
          DB      $02                         GENERIC EXPLOSIONS
          DB      $01
          DB      $00                    ;DEATH
          DB      $0E,$0E,$0F,$0F,$98    ;18 PING
          DB      $10,$10,$10,$10        ;1D  PING EXPL
          DB      $94                    ;GOTO 14
          DB      $11,$12                ;22 DRAGFLY
          DB      $A2                    ;GOTO 22
          DB      $13,$13,$13,$13        ;25 DRAGFLY EXPL
          DB      $94

* SHAPES *
FLSHPTBL
          DB      L(GENERXP2)            ;1 NEXT TO DEATH
          DB      L(GENERXP1)            ;2
          DB      L(GENERXP0)            ;3
          DB      L(SCRBEXP2)            ;4
          DB      L(SCRBEXP1)            ;5
          DB      L(GLIDEXP1)            ;6
          DB      L(GLIDEXP0)            ;7
          DB      L(GLIDER)              ;8
          DB      L(UNFOLD2)             ;9
          DB      L(UNFOLD1)             ;A
          DB      L(UNFOLD0)             ;B
          DB      L(SCARAB5)             ;C
          DB      L(SCARAB4)             ;D
          DB      L(PING1)               ;E
          DB      L(PING2)               ;F
          DB      L(PINGEXPL)           ;10
          DB      L(NEUFY1)             ;11
          DB      L(NEUFY2)             ;12
          DB      L(NEUFYXPL)           ;13

* SHADOWS *
FLSHDTBL
          DB      L(GENERXP2)            ;1 DEATH
          DB      L(GENERXP1)            ;2
          DB      L(GENERXP0)            ;3
          DB      L(SCRBEXP2)            ;4
          DB      L(SCRBEXP1)            ;5
          DB      L(GLIDEXP1)            ;6
          DB      L(GLIDEXP0)            ;7
          DB      L(GLSHAD)              ;8
          DB      L(UNFOLD2)             ;9
          DB      L(UNFOLD1)             ;A
          DB      L(UNFOLD0)             ;B
          DB      L(SCARAB5)             ;C
          DB      L(SCARAB4)             ;D
          DB      L(PING1)               ;E
          DB      L(PING2)               ;F
          DB      L(PINGEXPL)           ;10
          DB      L(NEUFY1)             ;11
          DB      L(NEUFY2)             ;12
          DB      L(NEUFYXPL)           ;13

** COLLISION DETECTION **
FLEADET   LDA     XTBL+FLEADEX,Y         ;X
          STA     COLPX
          LDA     COLY1+FLEADEX,Y        ;Y - DELTA
          STA     COLPY
          LDA     ZTBL+FLEADEX,Y         ;Z
          STA     COLPZ
          LDX     FLITBL,Y               ;LOAD IN REAL INDEX
          JSR     COLDET
          BNE     AXPLO                  ;EXPLOSION IF NOT ZERO
          LDA     COLX1+FLEADEX,Y        ;X-DELTA
          STA     COLPX
          LDA     COLY2+FLEADEX,Y        ;Y+DELTA
          STA     COLPY
          LDA     COLZ2+FLEADEX,Y        ;Z+DELTA
          STA     COLPZ
          LDX     FLITBL,Y               ;LOAD REAL INDEX
          JSR     COLDET
          BNE     AXPLO                  ;NON-ZERO MEANS COLLISION
          LDA     COLX1+FLEADEX,Y        ;X+DELTA
          STA     COLPX
          LDX     FLITBL,Y
          JSR     COLDET
          BEQ     ENDFLDET               ;NON-ZERO MEANS COLLISION

AXPLO
          LDX     FLEATYPE,Y
          LDA     FXITBL,X               ;LOOK UP EXPLOSION SEQUENCE START
          STA     FLEANIM,Y
          LDA     #0
          STA     FLEACNT,Y             ;FREEZE MOVEMENT
          STA     COLSTAT+FLEADEX,Y
          LDA     FLTUNE,X               ;JUST FOR JOHN, HONEST.
          JSR     TUNIN

ENDFLDET  RTS

KILLFLEA                                 ;CALL WITH FLEA INDEX IN A
          STX     TEMP2
          LDA     FLEATYPE-FLEADEX,X
          TAX
          LDA     FLTUNE,X
          JSR     TUNIN                  ;PLAY FLEA DEATH TUNE

          LDA     FLSCORE,X              ;DO SOME SCORING
          STA     HUNDS
          JSR     ADDSCORE
          JSR     ADDTRVAL               ;DO TREASURE VALUE UPDATE AS WELL

          LDA     FXITBL,X               ;LOOK UP EXPLOSION SEQ START
          LDX     TEMP2
          STA     FLEANIM-FLEADEX,X
          LDA     #0
          STA     FLEACNT-FLEADEX,X       ;FREEZE MOVEMENT
          STA     COLSTAT,X
          RTS

** FLEA MOVEMENT ROUTINE **
MOVEFLEA
          LDX     #NFLS-1
MVFLOOP
          LDA     FLEASTAT,X
          BEQ     FMNEXT

* Z COORDINATES *
          LDA     FZRUN,X
          SEC
          SBC     SCROLLS
          TAY
          CLC
          ADC     ZTBL+FLEADEX,X
          STA     ZTBL+FLEADEX,X
          CLC
          TYA
          ADC     ZTBL+FLSHDEX,X
          STA     ZTBL+FLSHDEX,X
          CLC
          TYA
          ADC     COLZ1+FLEADEX,X
          STA     COLZ1+FLEADEX,X
          CLC
          TYA
          ADC     COLZ2+FLEADEX,X
          STA     COLZ2+FLEADEX,X

* Y COORDINATES *
          LDY     FYRUN,X
          CLC
          TYA
          ADC     YTBL+FLEADEX,X
          CMP     #FLYLO                 ;BOUNDS CHECKS
          BCC     FMXCOORD
          CMP     #FLYHI
          BCS     FMXCOORD
          STA     YTBL+FLEADEX,X
          CLC
          TYA
          ADC     COLY1+FLEADEX,X
          STA     COLY1+FLEADEX,X
          CLC
          TYA
          ADC     COLY2+FLEADEX,X
          STA     COLY2+FLEADEX,X

* X COORDINATES *
FMXCOORD  LDY     FXRUN,X
          CLC
          TYA
          ADC     XTBL+FLEADEX,X
          CMP     #FLXLO                 ;BOUNDS CHECKS
          BCC     FMNEXT
          CMP     #FLXHI
          BCS     FMNEXT
          STA     XTBL+FLEADEX,X
          CLC
          TYA
          ADC     XTBL+FLSHDEX,X
          STA     XTBL+FLSHDEX,X
          CLC
          TYA
          ADC     COLX1+FLEADEX,X
          STA     COLX1+FLEADEX,X
          CLC
          TYA
          ADC     COLX2+FLEADEX,X
          STA     COLX2+FLEADEX,X

FMNEXT    DEX
          BPL     MVFLOOP

** INTELLIGENTLY MOVE ONE OF THE FLEAS **
          LDA     MAINCNT
          AND     #$03                   ;INDEX OF FLEA
          TAX
          LDA     FLEASTAT,X
          BEQ     FMVCPL
          JSR     FDSPATCH
FMVCPL    TXA
          ORA     #4
          TAX
          LDA     FLEASTAT,X
          BNE     FDSPATCH
FMRTS     RTS

** ATTACK INTERPRETER **
FDSPATCH
          LDY     FLEACNT,X
          LDA     MT,Y
          INC     FLEACNT,X
          STA     TEMP0
          LSR     A
          LSR     A
          LSR     A
          LSR     A
          TAY
          LDA     TEMP0
          AND     #$F
          STA     TEMP0
          LDA     FJMPLO,Y
          STA     PTR0
          LDA     FJMPHI,Y
          STA     PTR0+1
          JMP     (PTR0)

*** INSTRUCTION SET FOR FLEA MOVEMENT INTERPRETER ***

** STX    SET X TO BE THE LOW NIBBLE **
FSTX
          LDA     TEMP0
          CMP     #8
          BCC     FSTX1
          ORA     #$F0
FSTX1     STA     FXRUN,X
          JMP     FDSPATCH

** STY    SET Y TO BE THE LOW NIBBLE **
FSTY
          LDA     TEMP0
          CMP     #8
          BCC     FSTY1
          ORA     #$F0
FSTY1     STA     FYRUN,X
          JMP     FDSPATCH

** STZ    SET Z TO BE THE LOW NIBBLE **
FSTZ
          LDA     TEMP0
          CMP     #8
          BCC     FSTZ1
          ORA     #$F0
FSTZ1     STA     FZRUN,X
          JMP     FDSPATCH

** HBX    HOME TOWARDS BIRD IN X DIRECTION **
FHBX
          LDA     NOHOMING
          BNE     FHBX0
          LDA     XTBL+ZBIRD
FHBX0     SEC                            ;CALC COORD DIFFERENCE
          SBC     XTBL+FLEADEX,X
          ADC     #5
          BMI     FHBXDEC                ;FL>BD, DEC FLEA
          CMP     #10
          BCC     FHBXNIL
          LDA     TEMP0
          BNE     FHBX1
FHBXDEC   SEC
          LDA     #0
          SBC     TEMP0
          BNE     FHBX1
FHBXNIL   LDA     #0
FHBX1     STA     FXRUN,X
          JMP     FDSPATCH

** HBY    HOME TOWARDS BIRD IN Y DIRECTION **
FHBY
          LDA     NOHOMING
          LSR     A
          BNE     FHBY0
          LDA     YTBL+ZBIRD
FHBY0     SEC
          SBC     YTBL+FLEADEX,X
          ADC     #5
          BMI     FHBYDEC                ;FL>BD, DEC FLEA
          CMP     #10
          BCC     FHBYNIL
          LDA     TEMP0
          BNE     FHBY1
FHBYDEC   SEC
          LDA     #0
          SBC     TEMP0
          BNE     FHBY1
FHBYNIL   LDA     #0
FHBY1     STA     FYRUN,X
          JMP     FDSPATCH

** RTS    RETURN FROM INTERPRETER **
FRTS
          RTS

** CYC    CYCLE BACK N STEPS **
FCYC      LDA     FLEACNT,X
          CLC                            ;SUBT ONE MORE
          SBC     TEMP0
          STA     FLEACNT,X
          JMP     FDSPATCH

** LAN    LOAD ANIMATION INDEX WITH X **
FLAN
          LDA     TEMP0
          STA     FLEANIM,X
          JMP     FDSPATCH

** DIS    IF Z WITHIN A CERTAIN DISTANCE, JUMP **
FDIS      LDY     TEMP0
          LDA     FDISTBL,Y
          CMP     ZTBL+FLEADEX,X
          BCC     FDIS1
          LDY     FLEACNT,X
          LDA     MT,Y
          STA     FLEACNT,X
          JMP     FDSPATCH
FDIS1     INC     FLEACNT,X
          JMP     FDSPATCH

** RND    JUMP WITH PROBABILITY 1/ARG **
FRND      JSR     RANDOM
          AND     TEMP0
          BEQ     FJMP
          INC     FLEACNT,X
          JMP     FDSPATCH

** JMP    UNCONDITIONAL JUMP **
FJMP
          LDY     FLEACNT,X
          LDA     MT,Y
          STA     FLEACNT,X
          JMP     FDSPATCH

** SPN    SPAWN A NEW FLEA **
FSPN
          LDA     TEMP0                  ;X = CLASS OF SPAWNED FLEA
          STA     SPNCLASS
          LDA     NUMFLEAS
          BEQ     FSPNEND                ;ARE THERE ANY AVAIL FLEAS?
* FIX POSITION *
          LDA     XTBL+FLEADEX,X
          STA     SPNX
          LDA     YTBL+FLEADEX,X
          STA     SPNY
          LDA     ZTBL+FLEADEX,X
          ADC     #12
          STA     SPNZ
          JSR     SPAWN
FSPNEND
          JMP     FDSPATCH

FJMPLO    DB      L(FSTX),L(FSTY),L(FSTZ),L(FRTS)
          DB      L(FHBX),L(FHBY),L(FCYC),L(FDIS)
          DB      L(FSPN),L(FLAN),L(FJMP),L(FRND)
FJMPHI    DB      H(FSTX),H(FSTY),H(FSTZ),H(FRTS)
          DB      H(FHBX),H(FHBY),H(FCYC),H(FDIS)
          DB      H(FSPN),H(FLAN),H(FJMP),H(FRND)

MSTX      EQU     0
MSTY      EQU     $10
MSTZ      EQU     $20
MRTS      EQU     $30
MHBX      EQU     $40
MHBY      EQU     $50
MCYC      EQU     $60
MDIS      EQU     $70
MSPN      EQU     $80
MLAN      EQU     $90
MJMP      EQU     $A0
MRND      EQU     $B0

TARLOAD
          DB      MGLID1-MT,MGLID2-MT,MGLID3-MT,MGLID4-MT
          DB      MSCAB1-MT,MSCAB2-MT,MSCAB3-MT,MSCAB4-MT
          DB      MPING1-MT,MPING2-MT,MPING3-MT,MPING4-MT
          DB      MDRAG1-MT,MDRAG2-MT,MDRAG3-MT,MDRAG4-MT
TARPW
          DB      $9D,$BD,$DD,$1D,$9D,$BD,$DD,$1D
          DB      $9D,$BD,$DD,$1D,$9D,$BD,$DD,$1D    ;PALWIDTH FOR FLEAS
TARTYPE
          DB      $00,$00,$00,$00,$01,$01,$01,$01
          DB      $02,$02,$02,$02,$03,$03,$03,$03

* DISTANCE TABLE *
FDISTBL   DB      $B0,$A0,$90,$80

MIGLID1   EQU     0
MISCAB1   EQU     4
MIPING1   EQU     8
MIDRAG3   EQU     $E

*** MOVEMENT TABLE ***
MT
MEXPL     DB      MSTZ+$0,MSTY+$0,MSTX+$0,MRTS,MCYC+$1
MGLID1P   DB      MLAN+$2,MSTZ+$F,MRTS,MCYC+$1
MGLID1    DB      MSTZ+$E,MDIS+1,MGLID1P-MT,MRTS,MCYC+$3
MGLID2P   DB      MLAN+$2,MSTZ+$F
          DB      MSTY+$1,MRTS,MRTS,MSTY+$F,MRTS,MRTS,MCYC+$6
MGLID2    DB      MSTZ+$E,MDIS+3,MGLID2P-MT,MHBY+$1,MRTS,MCYC+$4
MGLID3P   DB      MLAN+$2,MSTZ+$D,MRTS,MSTZ+$E
          DB      MHBY+$1,MRTS,MCYC+$2
MGLID3    DB      MSTZ+$D,MDIS+2,MGLID3P-MT,MHBY+$2,MRTS,MCYC+$4
MGLID4P   DB      MLAN+$2,MSTZ+$D,MRTS,MSTZ+$E
          DB      MSTY+$1,MRTS,MHBY+$1,MRTS
          DB      MSTY+$F,MRTS,MHBY+$1,MRTS,MCYC+$8
MGLID4    DB      MSTZ+$D,MDIS+0,MGLID4P-MT,MHBY+$1,MRTS,MCYC+$4

MPING1    DB      MSTZ+$F,MHBX+$1,MHBY+$1,MRTS,MCYC+$3
MPING2    DB      MHBY+$1,MSTX+$2,MRTS,MRTS
          DB      MHBY+$1,MSTX+$E,MRTS,MRTS,MCYC+$8
MPING3    DB      MDIS+$2,MPING1-MT,MRTS,MCYC+$3
MPING4    DB      MSTZ+$E,MHBY+$1,MHBX+$2,MRTS
          DB      MHBY+$2,MSTX+$1,MRTS
          DB      MHBY+$2,MSTX+$F,MRTS
          DB      MHBY+$2,MRTS,MCYC+$B

MSCAB1A   DB      MSTZ+$0,MSTY+$0,MSTX+$0,MRTS
          DB      MRTS,MRTS,MRTS,MJMP,MPING1-MT
MSCAB1    DB      MSTZ+$F,MDIS+1,MSCAB1A-MT,MRTS,MCYC+$3
MSCAB2A   DB      MSTZ+$0,MSTY+$0,MSTX+$0,MRTS
          DB      MRTS,MRTS,MJMP,MPING4-MT
MSCAB2    DB      MSTZ+$F,MDIS+2,MSCAB2A-MT,MHBX+$1,MRTS,MCYC+$4
MSCAB3A   DB      MSTZ+$0,MSTX+$0
          DB      MHBY+$2,MRTS,MSTY+$E,MRTS
          DB      MSTZ+$E,MHBX+$2,MHBY+$1,MRTS,MCYC+$3
MSCAB3    DB      MDIS+$1,MSCAB3A-MT,MSTX+$1,MRTS,MSTX+$F,MRTS,MCYC+$6
MSCAB4A   DB      MSTZ+$0,MSTY+$1,MSTX+$1,MRTS
          DB      MSTY+$F,MRTS,MSTX+$F,MRTS,MSTY+$0,MRTS,MSTX+$0
          DB      MRTS,MSTZ+$D,MHBY+$4,MHBX+$4,MRTS
          DB      MHBY+$2,MHBX+$2,MRTS,MCYC+$3
MSCAB4    DB      MSTZ+$F,MDIS+1,MSCAB4A-MT,MRTS,MCYC+$3

MDRAG1A   DB      MSTZ+$0,MSTY+$0,MSTX+$0,MRTS
          DB      MRTS,MSPN+MISCAB1
          DB      MSTZ+$E,MJMP,MPING2-MT
MDRAG1    DB      MSTZ+$F,MDIS+0,MDRAG1A-MT,MRTS,MCYC+$3
MDRAG2A   DB      MSTZ+$0,MSTX+$0,MRTS
;         DB      MSTY+$F,MRTS,MSTY+$1,MRTS
          DB      MSTY+$F,MRTS,MSTY+$1,MRTS,MSPN+MIGLID1
MDRAG2    DB      MSTZ+$E,MSTX+$2,MRTS,MRTS
          DB      MSTX+$E,MRTS,MRTS,MRND+$1,MDRAG2A-MT,MCYC+$8
MDRAG3A   DB      MSTZ+$0,MSTY+$0,MSTX+$0,MRTS
          DB      MRTS,MRTS,MRTS,MSPN+MIDRAG3,MJMP,MPING4-MT
MDRAG3    DB      MSTZ+$F,MDIS+1,MDRAG3A-MT,MRTS,MCYC+$3
MDRAG4A   DB      MSPN+MIPING1,MRTS
MDRAG4    DB      MSTZ+$D,MRND+$1,MDRAG4A-MT,MRTS,MCYC+$3

*******************************************
**        UWE    ENEMY DRIVER            **
*******************************************
UWEOFFH   EQU     2
UWEOFFV   EQU     -13

NOUWE     EQU     0                      ;NO UWE AT ALL
WCTRLFL   EQU     TEMP8

** INITIALIZE A UWE **
DOUWE
          LDX     #UWEDEX+2              ;LOOK FOR AVAILABLE UWE
LOOKLP    LDA     UWESTATE-UWEDEX,X      ;THIS USED TO LOOK FOR VPTBL = TO
          BEQ     THISISX                ;SCREENBOT+1.  NOW LOOKS FOR ZERO
          DEX                            ;UWESTATE
          CPX     #UWEDEX                ;WE CAN PROBABLY PUNT THIS SCREENBOT+1
          BCS     LOOKLP                 ;SHIT AT THIS POINT
          LDA     #$00                   ;TELLS JOHN NOT TO DO UWES
          STA     UWEOK
          RTS

THISISX

          TXA                            ;IS THIS LAST UWE
          CMP     #UWEDEX
          BNE     TISX
          LDA     #$00
          STA     UWEOK

* INITIALIZE COORDS *
TISX      JSR     RANDOM                 ;RANDOM X FOR UWE
          AND     #$3F
          ADC     #58
          STA     XTBL,X
          LDA     #5                     ;AND 5 Y
          STA     YTBL,X
          JSR     RANDOM                 ;AND SOME RANDOM DISTANCE IN FRONT
          AND     #$1F
          ADC     ZTBL+ZBIRD
          ADC     #50
          STA     ZTBL,X

          LDA     #200                   ;HP SHOULD BE OFF SCREEN
          STA     HPTBL,X
          JSR     UWEVP                  ;DO THE VP
          STA     VPTBL,X

* INITIALIZE COLLISION DATA *
          LDA     XTBL,X                 ;THESE COLLISION PARAMETERS ARE
          SEC                            ;GUESSES
          SBC     #4
          STA     COLX1,X
          CLC
          ADC     #8
          STA     COLX2,X
          LDA     #1
          STA     COLY1,X
          LDA     #17
          STA     COLY2,X
          LDA     ZTBL,X
          STA     COLZ1,X
          CLC
          ADC     #10
          STA     COLZ2,X

* INITIAL STATE *
          JSR     RANDOM
          AND     #1
          STA     UWETYPE-UWEDEX,X
          LDA     #$DC                   ;PAL AND WIDTH
          STA     PWTBL,X

          LDA     #1                     ;START UNDERGROUND
          JSR     WSTINIT
          JSR     UWEDX
          JSR     OBJINS
          RTS

WSTINIT
          STA     UWESTATE-UWEDEX,X
          TAY
          LDA     WCOLST-1,Y
          STA     COLSTAT,X
          LDA     WSTST-1,Y
          STA     WANIMCNT-UWEDEX,X
          TAY
          LDA     UWESH,Y
          ORA     #$80
          STA     SHTBL,X
          LDA     UWESL,Y
          STA     SLTBL,X

          RTS

** UWE ANIMATION ROUTINE **
UWEANIM
          LDX     #UWEDEX+2

UANLP     LDA     UWESTATE-UWEDEX,X
          BNE     CONTUWE                ;STATE ZERO IS NO UWE

NEXTUWE   DEX
          CPX     #UWEDEX
          BCS     UANLP
          RTS


CONTUWE
* UWE DRIVER MAIN LOOP *

          JSR     UWEMOVE                ;MOVE UWES
          JSR     UWECOLD                ;DO COLLISION DETECTION

** UWE ANIMATION **
UWENIM    LDA     #0
          STA     WCTRLFL

          LDA     MAINCNT
          AND     #$03
          BNE     WPROJ

* THIS MAPS STATE TO GRAPHICS *
          LDY     WANIMCNT-UWEDEX,X
          CPY     #24                    ;*** DIAGNOSTIC
          BCC     WTRAP1                 ;WAS A TRAP
          LDA     #0                     ;JUST CLEAR IT
          STA     WANIMCNT-UWEDEX,X
          TAY
WTRAP1
          LDA     ZTBL,X                 ;CHECK LIMIT OF SCREEN
          CMP     #30
          BCC     KLUWE

          LDA     UWESH,Y                ;LOAD HIGH BYTE OF STAMP
          BEQ     KLUWE
          BMI     WNOFLAG
          ORA     #$80                   ;END OF SEQUENCE FLAG
          STA     WCTRLFL                ;CONTROL SHOULD CHANGE ANIMCNT

WNOFLAG   STA     SHTBL,X
          LDA     UWESL,Y
          STA     SLTBL,X
          INC     WANIMCNT-UWEDEX,X      ;UPDATE ANIMCNT

** DO THE PROJECTION **
WPROJ                                    ;THIS DOES THAT PROJECTION
          JSR     UWEHP
          STA     HPTBL,X
          JSR     UWEVP
          STA     VPTBL,X
          JSR     UWEDX
          JSR     OBJMOV                 ;MOVE HIM IN LINKED LIST
          JMP     WGTCHK

** DELETE UWE AND CLEAR STATE **
KLUWE                                    ;X CONTAINS UWE INDEX
          JSR     OBJDEL
          LDA     #$80
          STA     UWEOK
          LDA     #0
          STA     UWESTATE-UWEDEX,X
          LDA     #SCRENBOT+1
          STA     VPTBL,X
          LDA     #UWERUN
          JSR     SCRAPONE
          JMP     NEXTUWE

** GROUND TYPE CHECK **
WGTCHK    LDY     UWESTATE-UWEDEX,X
          LDA     WCGTBL,Y               ;FIND OUT WHAT TO CHECK
          BEQ     WCONTROL

          LDA     #0
          JSR     GRNDTYPE
          CMP     #78                    ;EMPIRICALLY DETERMINED
          BCS     WH2O
          LDA     WGTRANS,Y             ;GROUND TYPE TRANSITION
          BNE     WFINISH
          BEQ     WCONTROL

WH2O      LDA     WWTRANS,Y             ;WATER TYPE TRANSITION
          BNE     WFINISH

** UWE CONTROL **
WCONTROL
          LDA     WCTRLFL
          BEQ     WCPUNT

          LDA     #UWERUN
          JSR     SCRAPONE

          LDA     UWESTATE-UWEDEX,X
          SEC
          SBC     #1                     ;TAKE OUT NULL
          ASL     A
          ASL     A
          STA     TEMP9

* CALCULATE CHANGE INDEX (0-3) *
          LDY     UWETYPE-UWEDEX,X
          LDA     WHOMEP,Y
          BEQ     WRAND
          LDA     NOHOMING
          BNE     WHOME0
          LDA     XTBL+ZBIRD
WHOME0    SEC
          SBC     XTBL,X
          ADC     #8
          BMI     WTWO                   ;BIRD IS ON UWE'S RIGHT
          CMP     #16
          BCC     WONE
          LDA     #3
          BNE     WCIND
WTWO      LDA     #2
          BNE     WCIND
WONE      LDA     #1
          BNE     WCIND
WRAND     JSR     RANDOM                 ;PICK RND OF FOUR POSSIBLE STATES
          AND     #3

WCIND     ORA     TEMP9
          TAY
          LDA     WNEWST,Y
WFINISH   STA     UWESTATE-UWEDEX,X      ;NEW STATE ESTABLISHED
          TAY
          LDA     WCOLST-1,Y
          STA     COLSTAT,X
          LDA     WSTST-1,Y
          STA     WANIMCNT-UWEDEX,X      ;NEW ANIMATION ESTABLISHED

WCPUNT    JMP     NEXTUWE

* TRANSITIONS - NEW STATES *
WCGTBL            ;'CHECK GROUND?' TABLE
          DB      0,1,1,1,1,0,0          ;UWESTATES 0-6  1=YES 0=NO
WGTRANS           ;GROUND TYPE TRANSITIONS
          DB      0,6,0,0,0,0,0          ;UNDERGROUND TO RISING
WWTRANS           ;WATER TYPE TRANSITIONS
          DB      0,0,5,5,5,0,0          ;RUNNING TO DIVING

WNEWST           ;0 1 2 3 CONTROL
          DB      1,1,1,1                ;UNDER
          DB      2,2,3,4                ;! RUN
          DB      3,2,3,4                ;/ RUN
          DB      4,2,3,4                ;\ RUN
          DB      1,1,1,1                ;BURY
          DB      2,2,2,2                ;RISE

* MOVEMENTS *
WZMOV     DB      0,$FF,$FE,$FF,$FF,0,0,0
WXMOV     DB      0,0,0,$FF,1,0,0,0
WLIMCTRL  DB      0,1,2,2,2,5,6,7

WHOMEP    DB      0,1                    ;TYPE TO WHETHER IT HOMES

* COLSTATS *
WCOLST    DB      0,UWECOL,UWECOL,UWECOL,UWECOL,UWECOL

* STATE STARTS *
WSTST     DB      19                     ;UNDERGROUND
          DB      0                      ;STRAIGHT
          DB      2                      ;RIGHT
          DB      4                      ;LEFT
          DB      6                      ;BURY
          DB      9                      ;RISE
          DB      13                     ;EXPLODE

UWESL     DB      L(EWERUN1),L(EWERUN2)                     ;STRAIGHT 0
          DB      L(EWERITE1),L(EWERITE2)                   ;RIGHT    2
          DB      L(EWELEFT1),L(EWELEFT2)                   ;LEFT     4
          DB      L(EWEDIG3),L(EWEDIG2),L(EWEDIG1)          ;BURY     6
          DB      L(EWEDIG1),L(EWEDIG2),L(EWEDIG3)          ;RISE     9
          DB      L(EWEJUMP)
          DB      L(UWEEXPL1),L(UWEEXPL2)                   ;EXPLODE 13
          DB      L(GENERXP0),L(GENERXP1),L(GENERXP2),0
          DB      L(UWEBLANK)

* HIGH BYTE TABLE DOUBLES AS CONTROL *
UWESH     DB      H(EWERUN1),$40
          DB      H(EWERITE1),$40
          DB      H(EWELEFT1),$40
          DB      H(EWEDIG3),H(EWEDIG2),$40
          DB      H(EWEDIG1),H(EWEDIG2),H(EWEDIG3)
          DB      $40
          DB      H(UWEEXPL1),H(UWEEXPL2)
          DB      H(GENERXP0),H(GENERXP1),H(GENERXP2),0
          DB      $40


*         HPDO: HP CALCULATE ROUTINE
;THE CONSTANTS IN THIS ROUTINE ARE RUMORED TO BE CLOSE
UWEHP     LDA     XTBL,X
          SEC
          SBC     #126-UWEOFFH
          CLC
          ADC     ZTBL,X
          RTS

*         VPDO: VP CALCULATE ROUTINE
UWEVP     LDA     XTBL,X
          SEC
          SBC     ZTBL,X
          CLC
          ADC     #126+UWEOFFV
          SEC
          SBC     YTBL,X
          RTS

*         DXDO: DX CALCULATE ROUTINE
UWEDX     LDA     ZTBL,X
          SEC
          SBC     XTBL,X
          CLC
          ADC     #NUMBER+10+DXADJ       ; THIS IS DF
          STA     TEMP10
          SEC
          SBC     #12                    ; THIS IS DC
          STA     TEMP6
          RTS


KILLUWE
          STX     TEMP9
          LDA     #1                     ;SCORE SOME MEGA POINTS
          STA     HUNDS
          LDA     #$50
          STA     TENS
          JSR     ADDSCORE
          JMP     WSTEXPL


** UWE MOVEMENT **
UWEMOVE
          LDY     UWESTATE-UWEDEX,X
          LDA     WZMOV,Y
          SEC
          SBC     SCROLLS
          STA     TEMP9
          BEQ     WXMOVEM

          LDA     #UWERUN
          CMP     TUNNUM
          BEQ     RUNNINOW
          CMP     TUNNUM+1
          BEQ     RUNNINOW
          JSR     TUNIN

RUNNINOW
          LDA     TEMP9
          TAY
          CLC
          ADC     ZTBL,X
          STA     ZTBL,X

          TYA
          CLC
          ADC     COLZ1,X
          STA     COLZ1,X

          TYA
          CLC
          ADC     COLZ2,X
          STA     COLZ2,X

WXMOVEM   LDY     UWESTATE-UWEDEX,X
          LDA     WXMOV,Y
          BEQ     WMOVEND
          BMI     WXDEC
WXINC
          LDA     XTBL,X
          CMP     #FLXHI
          BCS     WSTRAIT
WXINC1    INC     XTBL,X
          INC     COLX1,X
          INC     COLX2,X
          JMP     WMOVEND
WXDEC
          LDA     XTBL,X
          CMP     #FLXLO
          BCC     WSTRAIT
WXDEC1    DEC     XTBL,X
          DEC     COLX1,X
          DEC     COLX2,X
          JMP     WMOVEND

WSTRAIT   LDA     WLIMCTRL-1,Y
          JSR     WSTINIT

WMOVEND   RTS

** COLLISION DETECTION **
UWECOLD
          LDA     UWESTATE-UWEDEX,X
          CMP     #7
          BEQ     WNOCOL1

          STX     TEMP9
          LDA     ZTBL,X
          CLC
          ADC     #2
          STA     COLPZ
          LDA     #5
          STA     COLPY
          LDA     XTBL,X
          CLC
          ADC     #4
          STA     COLPX
          JSR     COLDET
          BNE     WSTEXPL
          LDX     TEMP9

WNOCOL0

          LDA     XTBL,X
          SEC
          SBC     #4
          STA     COLPX
          JSR     COLDET
          BNE     WSTEXPL
          LDX     TEMP9

;         CMP     #HEIRO
 ;        BEQ     WNOCOL1
  ;       CMP     #PYRSTART
   ;      BCS     WSTEXPL
WNOCOL1
          RTS

WSTEXPL
          LDX     TEMP9
          LDA     #0
          STA     COLSTAT,X
          LDA     #7
          JSR     WSTINIT
          LDA     #UWEEXP
          JMP     TUNIN
          LDA     #UWEEXP
          JMP     TUNIN


** REMOVE ALL ON SCREEN ENEMIES AFTER BIRD DEATH **
CLEAN
          LDY     #FLEADEX+15
FLEADELP  LDA     FLEASTAT-FLEADEX,Y
          CMP     #1
          BNE     NEXTXOX                ;IF FLEA NOT ON SCREEN, NEXT FLEA

          LDA     FLITBL-FLEADEX,Y
          TAX

          JSR     OBJDEL

NEXTXOX   LDA     #0
          STA     FLEASTAT-FLEADEX,Y

          DEY
          CPY     #FLEADEX
          BCS     FLEADELP

          LDA     #0
          STA     NOHOMING
          LDA     #8
          STA     NUMFLEAS

* CLEAN OUT UWES *
          LDX     #UWEDEX+2
UWEDELP   LDA     UWESTATE-UWEDEX,X
          BEQ     NEXTOXO

          JSR     OBJDEL

NEXTOXO
          LDA     #0
          STA     UWESTATE-UWEDEX,X

          LDA     #SCRENBOT+1
          STA     VPTBL,X

          DEX
          CPX     #UWEDEX
          BCS     UWEDELP

          LDA     #$80
          STA     UWEOK

          RTS

** KILL ALL FLEAS - ALIAS SMART BOMB **
KAFLEAS
          LDX     #FLEADEX+NFLS-1
FLPOW                                    ;KILL EACH FLEA
          LDA     FLEASTAT-FLEADEX,X
          BEQ     FLPOWNXT
          JSR     KILLFLEA

FLPOWNXT  DEX
          CPX     #FLEADEX
          BCS     FLPOW
          RTS

** KILL ALL UWES **
KAUWES
          LDX     #UWEDEX+2
UWPOW                                    ;KILL EACH UWE
          LDA     UWESTATE-UWEDEX,X
          BEQ     UWPOWNXT
          JSR     KILLUWE

UWPOWNXT  DEX
          CPX     #UWEDEX
          BCS     UWPOW
          RTS

*** FREEZE FLEAS ***
FRFLEAS
          LDX     #NFLS-1
FLFRZ                                    ;FREEZE EACH FLEA
          LDA     #MEXPL-MT
          STA     FLEACNT,X

FLFRZNXT  DEX
          BPL     FLFRZ
          RTS

          END
****      ZERODEF.S   ZERO PAGE RAM MACRO *****
********************************************************************************
*                 ZERO PAGE RAM  40-7F                                         *
********************************************************************************

* HEY GUYS, IF THERE ARE ANY LABELS IN THIS GLBL LIST THAT CAN BE REMOVED PLEASE
* DO SO.

ZERODEF   MACRO

********************************************************************************

* RAM LOCATIONS DEFINED IN SDEF.S

          GLBL    VAR1,VAR2,VAR3,VAR4,VAR5

          GLBL    PSRANDA1,PSRANDA2,PSRANDB1,PSRANDB2
          GLBL    SVDIST,SVHDIST,SVGRNDPC,SVOBJTYP,SVNEWBLK,SVBLOCK,SVBAND

          GLBL    WAITING,WAVECNT,PARAM,SPNCLASS,UWEOK,TAKEOVER
          GLBL    GCOARSE,PHASE,LOADFDEX,LEFTMASK,MIDMASK,RIGTMASK

          GLBL    P5C2SHAD,P1C2SHAD,P2C2SHAD,P0C2SHAD,P1C2SHDB
          GLBL    PERIOD,NEXFRAME,HOWMANY,STATIMER,SWCHBIO,OLDSWCHB,TITCNT
          GLBL    OTIMER,LEFTBUT,STIMER,ETIMER,WTIMER,GSCRFLAG,ONEBUT,RIGHTBUT

          GLBL    SCRLLCNT,DLLIST,NULHDR,STUFFDEX,PTRTBLLO,PTRTBLHI
          GLBL    ZBUFF0,ZBUFF1,ZBUFF2,ZBUFF3,ZBUFF4,ZBUFF5,ZBUFF6,ZBUFF7
          GLBL    ZBUFF8,ZBUFF9,ZBUFFA,ZBUFFB
          GLBL    DL0,DL1,DL2,DL3,DL4,DL5,DL6,DL7,DL8,DL9,DL10,DL11

          GLBL    STAMPID,ZONESBK,HPOS,FRBUFPTR,FRBUFSTK
          GLBL    SLTBL,SHTBL,SMTBL,PWTBL,HPTBL,VPTBL,XTBL,YTBL,ZTBL,DXTBL,DFTBL
          GLBL    COLSTAT,COLX1,COLX2,COLY1,COLY2,COLZ1,COLZ2

          GLBL    MININUMB,MINITBL,SPHXSHTD,MINIOVER,LOWFACE,HIFACE,FACER,ROLLER
          GLBL    SPNCNT,SPNX,SPNY,SPNZ,FIRENUMB,FIRETIP,FIREANIM,FIREHGHT
          GLBL    FIREGOAL,FIRECOL1,FIRECOL2,FIREMODE,SXSHTSTT,SHOTDEL,HIEROSLT
          GLBL    SPHNXNSX,SPHNXNSY,SEXP1,SEXP2,SEXP3

          GLBL    JEWCNT,BARCNT,EGGCNT,TRDSPFLG,BOTMSMAP,TOPMSMAP,ROTATE

          GLBL    FLEACNT,FXRUN,FYRUN,FZRUN,FLEATYPE
          GLBL    UWETYPE,UWESTATE,WANIMCNT

          GLBL    PTIMER,TPSTART,TPNUMB
          GLBL    NOHOMING,CANTHOP,CANTSWIM,CANTFLY,HOVER,SPEEDUP,SLOWDOWN
          GLBL    QUIKSHOT,INVINCBL
          GLBL    PARASPHX

          GLBL    PL1LVMAP,PL2LVMAP,PL1MAP,PL2MAP,FUCKFLAG

          GLBL    LLTBL,RLTBL,SLOTQ,SLOTGPTR,SLOTRPTR

          GLBL    VRUN,DBK0,TBINDX0,CBINDX0,VBINDX0,VBRUN

          GLBL    BNSTIMER,BNSTIME,BNSTENS,BNSHUNDS,BNSHTHS,SECOND,TUNREPT0
          GLBL    TUNREPT1

          GLBL    IOSIM,SWIMMING,SHOTSTAT,DEATH,WARP

          GLBL    HSCIN,HSGAMDAT,DIFNAM,HSLSTEXP

          GLBL    DLY,DLZ,WINGMAP0,WINGMAP1,WINGMAP2,WINGMAP3,WINGMAP4,WINGMAP5
          GLBL    CRSTMAP1,CRSTMAP2,CRSTMAP3,CRSTMAP4,CRSTMAP5
          GLBL    NOVMAP,STDMAP,ADVMAP,EXPMAP,CRMAP

          GLBL    WAITCNT,OSCRLCNT       ; ARE THESE 2 REALLY USED ??????

*         LINKED LIST DIAGNOSTICS     USED IN SOBJ.S

          GLBL    TESTLIST,ORDTEST

********************************************************************************

* SOUNDS

          GLBL    BRDSHOT,MINISHOT,RICCHET
          GLBL    ALADIN0,ALADIN1,ENDGAM0,ENDGAM1
          GLBL    UWEEXP,SCBEXPL,GLDEXPL,MINIBM
          GLBL    SWIM,RUNNING,VHDEATH,CUCKOO1,CUCKOO2
          GLBL    UWERUN,SPTUNE,SFINKS
          GLBL    NHIERO2,JWTUNE,XLPOWER
          GLBL    NHIERO1,NHIERO3,HMISS3,POWRUSE,SPHXBM0,SPHXBM1
          GLBL    HISCOR0,HISCOR1,HISEND0,HISEND1,LOSCOR0,LOSCOR1,LOSEND0
          GLBL    LOSEND1,BACKGR0,BACKGR1,FLASHT0,FLASHT1

********************************************************************************

* GRAPHICS

          GLBL    BIRDFMS,BIRDFUS,BIRDFDS,BIRDFMR,BIRDFUR,BIRDFDR
          GLBL    BIRDFML,BIRDFUL,BIRDFDL,BIRDSD,BIRDSU,FIRSTBOT
          GLBL    BIRDLD,BIRDLU,BIRDHDS,BIRDHDL,BIRDHDR,BIRDHUS,BIRDHUL
          GLBL    BIRDHUR,BIRDTU1,BIRDTD,BIRDTU2,BIRDWS,BIRDWR,BIRDWL

          GLBL    SHADSU,SHADSD,SHADHUR,SHADHUS,SHADHUL,SHADHDR,SHADHDS,SHADHDL

          GLBL    BDS1,BDS2,BDS3,BDS4,BDS5,BDS6

          GLBL    BIGPYR0,BIGPYR1
          GLBL    OPEPYR0,OPEPYR1,OPEPYR2
          GLBL    OBELISK2,OBELISK1,OBELISK0

          GLBL    CANEH,EYEH,AHNKH,BOWLH,MANWSTAF,FEATHER,BIRDH,SUNOWTRH

          GLBL    GEM,EGG,BAR

          GLBL    SPHINXL1,SPHINXL2,SPHINXL3,SPHINXL4,SPHINXR2,SPHINXR3,SPHINXR4
          GLBL    SPFACE1L,SPFACE1H,SPFACE2L,SPFACE2H,SPFACE3L,SPFACE3H
          GLBL    SPFACE4L,SPFACE4H,SPFACE5L,SPFACE5H,CRATERL,CRATERH

          GLBL    SPHXGLMR,SPHXFLSH,SPHXEXPL,BLANK

          GLBL    MINISPH0,MINISPH1
          GLBL    MINIEXP1,MINIEXP2,MINIEXP3

          GLBL    POT,COL1,COL2,TIP1,TIP2,TIP3

          GLBL    GLIDER,GLSHAD,UNFOLD0,UNFOLD1,UNFOLD2,GLIDEXP0,GLIDEXP1

          GLBL    SCARAB4,SCARAB5,SCRBEXP1,SCRBEXP2

          GLBL    PING1,PING2,PINGEXPL

          GLBL    NEUFY1,NEUFY2,NEUFYXPL

          GLBL    EWERUN1,EWERUN2,EWEJUMP,EWEDIG3,EWEDIG2,EWEDIG1,UWEBLANK
          GLBL    EWELEFT1,EWELEFT2,EWERITE1,EWERITE2,UWEEXPL1,UWEEXPL2

          GLBL    GENERXP0,GENERXP1,GENERXP2

          GLBL    SHOTAN0,SPSHOTST

          GLBL    A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z

          GLBL    EQUALS,CRIGHT,BLANKCHR,XTRA

          GLBL    LCANE,LMWS,LFEATH,LEYE,LAHNK,LBIRD,LSUN,LBOWL

          GLBL    JEWCON,BARCON,EGGCON

          GLBL    CHARS,NUMBERS

          GLBL    TITCHR1,TITCHR7,TITCHR13,TITCHR19

          GLBL    WINGS0,WINGS1,WINGS2,WINGS3,WINGS4,WINGS5
          GLBL    WINGS6,WINGS7,WINGS8,WINGS9

********************************************************************************

* ROUTINES CALLED FROM OTHER FILES AND CONSTANTS REFERENCED FROM OTHER FILES

********  SCOLON.S    COLLISION SHIT

          GLBL    COLDET,COLDTNC,HIERODET,GRNDTYPE,GRNDFLO

*         SPHINX - SENEMIES

          GLBL    FLEAINIT,SPAWN,ANIMFLEA,KILLFLEA,DOUWE,UWEANIM,KILLUWE,CLEAN
          GLBL    KAFLEAS,KAUWES,FRFLEAS

*         SPHINX--SGAME.S

          GLBL    GAME,PLACEMNT

*         * CONSTANTS

          GLBL    ZBIRDZ,SHADANAD

*******   SGNDOBJ.S    THE AMAZING SPHINX

          GLBL    MINIINIT,MINIKILL,DOMINIS,SXFLINIT,SXFHINIT,DOSPHINX,KILLSPHX
          GLBL    FIREINIT,DOFIRE,DOSXSHTS,DELTREAS,GLOHIERO,DOHIEROS
          GLBL    KAFIRES,KAMINIS

*         HIGH SCORE CARD INTERFACE FOR THE DESERT FALCON GAME

          GLBL    HSPOWNIT,HSGAMOVR,HSDISP

*         SPHINX--SINIT.S

          GLBL    PREINIT,INITIT,DIFFTWID,PLAYTWID,TOTINIT,TOTINIT2,INITGAME
          GLBL    INITNPLR,INITAUTO,INITLOGO

*         SPHINX--SKERNEL.S

          GLBL    DLITOP,DLITIT,DLIZ11,DLZ11A,STARTUP,GAMSTATE,TITSTATE,ATOSTATE
          GLBL    DLIHSC0
          GLBL    RANDOM

********SMAGIC.S  PROCESS POWERS AND TREASURES

          GLBL    GOTTREAS,HITTREAS,LDTREAS,ADDTRVAL,GOTHIERO,GIVPOWER,LDHIEROS
          GLBL    INITRSMP,INITBNS,ENDBONUS,CLRPFLGS

*         SPHINX--SMCP.S

          GLBL    MCPINIT,MCPINIT2,ENEMYMCP,GRNDMCP,COLINIT,NEWBLOCK,CRISVARS

*******SOBJ.S     LINKED LIST MANIPULATION SHIT

          GLBL    OBJINS,OBJDEL,OBJMOV,VSCRP,GETASLOT,RETASLOT

********SSCROBJ.S NEW SCROLLING OBJECT SHIT

          GLBL    SCRLOAD,SCRBUF

*         SPHINX--SSCROLL.S

          GLBL    SCROLL

*         * CONSTANTS

          GLBL    ZPALWID,ZSTHPOS,HIBYE,BLOCK9,MASK9L,MASK9R

*         SPHINX--SSUBRS.S

          GLBL    ADDSCORE,LDLIVES,LDSCORE,LOADER

*         STUNES.S      by Kevin G. Osborn

          GLBL    SCRAPALL,SCRAPONE,TUNIN,TUNER,BACKON,RUNBACK

********************************************************************************

*         ZERO PAGE EQUATES

*         GAME STATE AND ASSOCIATED RAM
*         LEVEL 1 RAM
HANDLER   EQU     $40                    ;HAS A 40 (JMP OPCODE) TO JMP TO DLIPT
DLIPTR    EQU     $41     2              ;AND E4
TITLMENU  EQU     $43                    ;FLAGS FOR STATES: ACTIVE LOW
AUTOPLAY  EQU     $44                    ;ACTIVE HIGH
USEME     EQU     $45                    ;FREE BYTE
DMA       EQU     $46                    ;ACTIVE HIGH
HSC       EQU     $47                    ;ACTIVE HIGH
GAMEU     EQU     $48                    ;ACTIVE HIGH
STATEPTR  EQU     $49     2              ;STATEPTR FOR GAME STATE (i.e. PAUSE..
DIFCULTY  EQU     $4B                    ;DIFFICULTY LEVEL
PAUSE     EQU     $4C                    ;PAUSE STATE FLAG
NUMPLYRS  EQU     $4D                    ;NUMBER OF PLAYERS
RNDOM     EQU     $4E                    ;RANDOM NUMBER
RNDOM1    EQU     $4F                    ;RANDOM NUMBER
FUTEXP1   EQU     $50     2              ;NO ROOM FOR FUTURE EXPANSION

*         LEVEL 2 RAM
RACK      EQU     $52     2              ;SPHINX LEVEL
FREEZEP   EQU     $54                    ;FREEZE FRAMER VARIABLE ACTIVE HIGH
PAWSTWID  EQU     $55                    ;PAUSE TWIDDLE FLAG
GAMEOVR   EQU     $56                    ;ACTIVE HIGH
NEWPLYR   EQU     $57                    ;SWITCHING BETWEEN PLAYERS FLAG
PLAYER    EQU     $58                    ;WHICH PLAYER IS UP 0 >> 1,  1>> 2
PL1SCORE  EQU     $59      4             ;PLAYER 0'S SCORE
PL2SCORE  EQU     $5D      4             ;PLAYER 1'S SCORE
PL1LIVES  EQU     $61                    ;PLAYER 0'S LIVES
PL2LIVES  EQU     $62                    ;PLAYER 1'S LIVES
GRNDPC    EQU     $63                    ;GROUND OBJECTS PROGRAM COUNTER
OBJTYP    EQU     $64                    ;OBJECT TYPE OF PATTERN
DISTANCE  EQU     $65                    ;NUMBER OF COARSE SCROLLS
HDIST     EQU     $66                    ;HIGH BYTE OF DISTANCE
PGNUM     EQU     $67     2              ;PLAYERS' NUMBER OF GLYPHS
PGPOWER   EQU     $69     2              ;PLAYERS' CURRENT POWER
PGS1      EQU     $6B     3              ;PLAYER ONE'S HEIROS
PGS2      EQU     $6E     3              ;PLAYER TWO'S HEIROS
PSRA1     EQU     $71                    ;LAND PROGRAM RANDOMS
PSRA2     EQU     $72
PSRB1     EQU     $73
PSRB2     EQU     $74
DUMPAREA  EQU     $75     2              ;QUEUE VAR FOR MCP
DIFIND    EQU     $77                    ;DIFICULTY LEVEL
EATME     EQU     $78                    ;AVAILABLE BYTE
TRVAL1    EQU     $79     2
TRVAL2    EQU     $7B     2
XTRBNSTM  EQU     $7D     2              ;EXTRA BONUS TIME
FUTEXP2   EQU     $7F     1              ;NO MORE ROOM FOR EXPANSION

*         LEVEL 3 RAM
*         TEMPS AND POINTERS
PTR0      EQU     $80     2              ;TEMPS AND POINTERS
PTR1      EQU     $82     2
TEMP0     EQU     $84
TEMP1     EQU     $85
TEMP2     EQU     $86
TEMP3     EQU     $87
TEMP4     EQU     $88
TEMP5     EQU     $89
TEMP6     EQU     $8A
TEMP7     EQU     $8B
TEMP8     EQU     $8C
TEMP9     EQU     $8D
TEMP10    EQU     $8E                    ;JUST FOR PASSING DF
TEMPX     EQU     $8F
TEMPY     EQU     $90

COLPX     EQU     TEMP1                  ;X PASSED TO COLLISION DETECTION
COLPY     EQU     TEMP2                  ;Y PASSED TO COLLISION DETECTION
COLPZ     EQU     TEMP3                  ;Z PASSED TO COLLISION DETECTION

KTEMPX    EQU     $91                    ;TEMPX AND Y FOR INTERRUPT CODE
KTEMPY    EQU     $92
KTEMP2    EQU     $93
KTEMP3    EQU     $94
KTEMP10   EQU     $95                    ;KERNEL TEMPORARY
KPTR0     EQU     $96     2              ;POINTERS FOR INTERRUPT CODE
KPTR1     EQU     $98     2
KPTR      EQU     $9A     2

JTEMP     EQU     $9C                    ;WHAT THE FUCK

*         RANDOM BOB K. TEMPS  WHAT CAN WE DO WITH THEM
OTEMP1    EQU     $9D                    ;BOBS TEMPS
OTEMP2    EQU     $9E
OTEMP3    EQU     $9F
OTEMP4    EQU     $A0

*         RANDOM,BOGUS AND OTHERS
ZONEOFF   EQU     $A1                    ;OFFSET INTO 16 HIGH ZONE (FF-F)
FRMCNT    EQU     $A2                    ;FRAME COUNTER MOD 256
OLDFRM    EQU     $A3                    ;LAST FRAME'S FRAME COUNT
SCRDELTA  EQU     $A4                    ;DELTA VS NORMAL SCROLL
JERKOFF   EQU     $A5                    ;COUNTER FOR COARSE H SCROLL
SCRATE    EQU     $A6                    ;SCROLL RATE
LASTSCRL  EQU     $A7                    ;COUNTER FROM 0 TO SCRATE
BIRDACNT  EQU     $A8                    ;BIRD'S ANIMATION DELAY
BIRDXCNT  EQU     $A9                    ;BIRD'S X MOTION DELAY
BIRDSTAT  EQU     $AA                    ;BIRD'S STATUS (ANIMATION?)
BLOCK     EQU     $AB                    ;CURRENT BLOCK BEING SCROLLED ON SCREE
BAND      EQU     $AC                    ;CURRENT BAND IN BLOCK TO BE SCROLLED
FIRECNT   EQU     $AD                    ;FIRE BUTTON DELAY
SHOTCNT   EQU     $AE                    ;NUMBER OF SHOTS ON SCREEN (MAX IS 4)
BLKCNT    EQU     $AF                    ;BLOCK COUNT

NBFLAG    EQU     $B0                    ;FLAG THAT SAYS NEW BLOCK IS READY
NEWBLK    EQU     $B1                    ;NEW BLOCK NUMBER

TENS      EQU     $B2                    ;VALUES PASSED TO SCORE ROUTINE
HUNDS     EQU     $B3                    ;COULD BE TEMPS ALSO I BELIEVE
HUNTHOUS  EQU     $B4

ZNDLPOS   EQU     $B5     24             ;FIRST EMPTY BYTE IN EACH DISP. LIST
LOWEST    EQU     $CD                    ;START OF RLTBL

KTEMP0    EQU     $CE                    ;TEMPS FOR INTERRUPT CODE
KTEMP1    EQU     $CF                    ;KTEMP0 AND 1 MUST BE PAST $C0

MPTRL     EQU      KTEMP0                ;ZERO PAGE TEMP(NOT GAMEPLAY)
MPTRH     EQU      KTEMP1                ;ZERO PAGE TEMP(NOT GAMEPLAY)

HIGHEST   EQU     $D0                    ;OPPOSITE OF LOWEST.. END OF RLTBL
SCROLLS   EQU     $D1                    ;NUMBER OF SCROLLS THIS FRAME

MAINCNT   EQU     $D2                    ;MAIN LOOP COUNTER

*FLEA STATE
FLEASTAT  EQU     $D3     16             ;16 FLEA STATUS PRE/ON/OFF SCREEN
FLEANIM   EQU     $E3     8              ;8  FLEA ANIMATION STATE
NUMFLEAS  EQU     $EB                    ;NUMBER OF FLEAS CURRENTLY AROUND
FLSYSCLK  EQU     $EC                    ;FLEA SYSTEM CLOCK

BUFDEX    EQU     $ED                    ;INDEX OF BUFFER WITH CHAR MAPS (0-11)

BACKCOL   EQU     $EE                    ;BACKGROUND FOR PLAY AREA
D11CBASE  EQU     $EF                    ;CHARBASE FOR BOTTOM ZONE OF SCREEN

DLZDEST   EQU     $F0     2              ;POINTER TO DESTINATION OF DLI AT
                                         ;BEGINNING OF ZONE 11

DCH0      EQU     $F2                    ;ONE BYTE--DURATION CNTR CHAN. 0
DCH1      EQU     $F3                    ;ONE BYTE--DURATION CNTR CHAN. 1
TUNNUM    EQU     $F4                    ;ONE BYTE--TUNE NUM FOR CHAN. 0
TUNNUM1   EQU     $F5                    ;ONE BYTE--TUNE NUM FOR CHAN. 1
TINDEX0   EQU     $F6                    ;ONE BYTE--NOTE POINTER 0
TINDEX1   EQU     $F7                    ;ONE BYTE--NOTE POINTER 1
CINDEX0   EQU     $F8                    ;CONTROL INDEX0
CINDEX1   EQU     $F9                    ;CONTROL INDEX1
VINDEX0   EQU     $FA                    ;VOLUME INDEX0
VINDEX1   EQU     $FB                    ;VOLUME INDEX1
TUNTEMP   EQU     $FC                    ;COULD BE A TEMP

RUNLOAD   EQU     $FD                    ;TELLS LOADER TO RUN, SET BY MAINLOOP
ENDRAM0   EQU     $FD                    ;MOVE ME AS NEEDED  YES SIR


*         OBJECT INDEX EQUATES

ZBIRD     EQU     0                      ;0                      BIRD
ZSHOT1    EQU     1                      ;1,2,3,4                SHOTS
FLEADEX   EQU     5                      ;5,6,7,8,9,10,11,12     FLEAS
UWEDEX    EQU     13                     ;13,14,15               UWES
PYRSTART  EQU     16                     ;16-58                  SCROLLING OBJS
PYRSTOP   EQU     58
SPHXSHOT  EQU     59                     ;59,60,61,62            SPHINX SHOTS
LASTPNT   EQU     63                     ;COMPARE VALUE FOR LAST COLLISIONS
FLSHDEX   EQU     63                     ;63 - 70                FLEA SHADOWS
ZSHAD     EQU     71                     ;71                     BIRD SHADOW
SHOTSHAD  EQU     72                     ;72,73,74,75            SHOT SHADOWS
SPXSHTSH  EQU     76                     ;76,77,78,79            SPHNX SHT SHDS
ZREF0     EQU     80                     ;80                     REFERENCE POINT
ZREF1     EQU     81                     ;81                     REFERENCE POINT
ZREF2     EQU     82                     ;82                     REFERENCE POINT
ZREF3     EQU     83                     ;83                     REFERENCE POINT


*         RANDOM EQUATES
SHOTDIFF  EQU     SHOTSHAD-ZSHOT1        ;DIFFERENCE BETWEEN SHOTS AND THEIR
                                         ;SHADOWS
NUMBER    EQU     126                    ;96 + Z OF LOWER LEFT CORNER OF SCREEN
DXADJ     EQU     L(-16)                 ;ADJUST THE RANGE OF DX'S
LOWATER   EQU     72                     ;LOWEST WATER CHARACTER NUMBER
SCRENBOT  EQU     176

*         COLISION BOX ID'S
HIEROCOL  EQU     1                      ; 1 THRU 8  - HIEROGLYPHS
TREASCOL  EQU     9                      ; 9 THRU 11 - TREASURES
PASSVCOL  EQU     12                     ; ALL PASSIVE OBJECTS
MINICOL   EQU     13                     ; MINI SPHINX TARGET
SPHNXCOL  EQU     14                     ; BIG SPHINX TARGET
FLEACOL   EQU     15                     ; FLEAS
UWECOL    EQU     16                     ; UWES
SXSHTCOL  EQU     17                     ; SPHINX SHOTS
FIRECOL   EQU     18                     ; FIRE

                                         ;CAN BE ANYTHING ELSE BUT 0

***       SPHINX--SPROLOG.S


* TIA REGISTERS
INPT4R    EQU     $08                    ;PLAYER 0, RIGHT BUTTON (PADDLE INPUT)
INPT4L    EQU     $09                    ;PLAYER 0, LEFT BUTTON (PADDLE INPUT)
INPT5R    EQU     $0A                    ;PLAYER 1, RIGHT BUTTON (PADDLE INPUT)
INPT5L    EQU     $0B                    ;PLAYER 1, LEFT BUTTON (PADDLE INPUT)

INPT4     EQU     $0C                    ;PLAYER 0 FIRE BUTTON
INPT5     EQU     $0D                    ;PLAYER 1 FIRE BUTTON
AUDC0     EQU     $15      ;BITS     3210 AUDIO CONTROL 0
AUDC1     EQU     $16      ;BITS     3210 AUDIO CONTROL 1
AUDF0     EQU     $17      ;BITS     3210 AUDIO FREQUENCY 0
AUDF1     EQU     $18      ;BITS     3210 AUDIO FREQUENCY 1
AUDV0     EQU     $19      ;BITS     3210 AUDIO VOLUME 0
AUDV1     EQU     $1A      ;BITS     3210 AUDIO VOLUME 1


* MARIA REGISTERS
BACKGRND  EQU     $20                    ;BACKGROUND COLOR                  RW
P0C1      EQU     $21                    ;PALETTE ZERO COLOR ONE            RW
P0C2      EQU     $22                    ;PALETTE ZERO COLOR TWO            RW
P0C3      EQU     $23                    ;PALETTE ZERO COLOR THREE          RW
WSYNC     EQU     $24                    ;FAST MARIA WSYNC STROBE
P1C1      EQU     $25                    ;PALETTE ONE COLOR ONE             RW
P1C2      EQU     $26                    ;PALETTE ONE COLOR TWO             RW
P1C3      EQU     $27                    ;PALETTE ONE COLOR THREE           RW
MSTAT     EQU     $28                    ;BIT 6 IN VBLANK, BIT ? IN DISPLAY RO
P2C1      EQU     $29                    ;PALETTE TWO COLOR ONE             RW
P2C2      EQU     $2A                    ;PALETTE TWO COLOR TWO             RW
P2C3      EQU     $2B                    ;PALETTE TWO COLOR THREE           RW
DPPH      EQU     $2C                    ;DISPLAY LIST POINTER HIGH         WO
P3C1      EQU     $2D                    ;PALETTE THREE COLOR ONE           RW
P3C2      EQU     $2E                    ;PALETTE THREE COLOR TWO           RW
P3C3      EQU     $2F                    ;PALETTE THREE COLOR THREE         RW
DPPL      EQU     $30                    ;DISPLAY LIST POINTER LOW          WO
P4C1      EQU     $31                    ;PALETTE FOUR COLOR ONE            RW
P4C2      EQU     $32                    ;PALETTE FOUR COLOR TWO            RW
P4C3      EQU     $33                    ;PALETTE FOUR COLOR THREE          RW
CHARBASE  EQU     $34                    :CHARACTER MODE HIGH POINTER       WO
P5C1      EQU     $35                    ;PALETTE FIVE COLOR ONE            RW
P5C2      EQU     $36                    ;PALETTE FIVE COLOR TWO            RW
P5C3      EQU     $37                    ;PALETTE FIVE COLOR THREE          RW
OFFSET    EQU     $38                    ;GRAPHICS HIGH POINTER OFFSET      RW
P6C1      EQU     $39                    ;PALETTE SIX COLOR ONE             RW
P6C2      EQU     $3A                    ;PALETTE SIX COLOR TWO             RW
P6C3      EQU     $3B                    ;PALETTE SIX COLOR THREE           RW
CTRL      EQU     $3C                    ;MAGIC                             WO
P7C1      EQU     $3D                    ;PALETTE SEVEN COLOR ONE           RW
P7C2      EQU     $3E                    ;PALETTE SEVEN COLOR TWO           RW
P7C3      EQU     $3F                    ;PALETTE SEVEN COLOR THREE         RW


* 6532  TIMERS AND PORTS
SWCHA     EQU     $280  ;PO, P1 JOYSTICKS
;         BIT 7 PLAYER 0 EAST IF CLEAR
;         BIT 6          WEST
;         BIT 5          SOUTH
;         BIT 4          NORTH
;         BIT 3 PLAYER 1 EAST IF CLEAR
;         BIT 2          WEST
;         BIT 1          SOUTH
;         BIT 0          NORTH

SWCHB     EQU     $282  ;CONSOLE SWITCHES
;         BIT 7   PLAYER 1 DIFFICULTY A IF SET B IF CLEAR
;         BIT 6   PLAYER 0 DIFFICULTY A IF SET B IF CLEAR
;         BIT 3   BLACK + WHITE/COLOR  COLOR WHEN SET
;         BIT 1   GAME SELECT  CLEAR WHEN PRESSED
;         BIT 0   GAME RESET   CLEAR WHEN PRESSED

CTLSWA    EQU     $281
CTLSWB    EQU     $283
INTIM     EQU     $284  ;INTERVAL TIMER IN
INTIMI    EQU     $28C  ;INTERRUPT INTERVAL TIMER IN
TIM8T     EQU     $295  ;TIMER 8T WRITE OUT
TIM64T    EQU     $296  ;TIMER 64T WRITE OUT
TIM64TI   EQU     $29E  ;INTERUPT TIMER 64T

*         HIGH SCORE EQUATES
HSCSTAT   EQU     $3FF7
HSCATRCT  EQU     $3FFA
HSCENTER  EQU     $3FFD
HSCSETRS  EQU     $3FEB
DFNMADAD  EQU     PTR0

          ENDM
